-- For use with 'How to create an ATOM feed from a DataSet'

use FeedSample

CREATE TABLE [dbo].[Channel] (
	[Title] varchar (500) NULL,
	[Link] varchar (500) NULL,
	[Description] varchar (500) NULL,
	[Language] varchar (50) NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Entries] (
	[Title] varchar (500) NULL,
	[Link] varchar (500) NULL,
	[Updated] datetime NULL,
	[Summary] varchar (500) NULL,
	[Id] varchar (100) NULL,
	[id1] varchar (100) NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Feed] (
	[Title] varchar (500) NULL,
	[Link] varchar (500) NULL,
	[Updated] datetime NULL,
	[Author] varchar (100) NULL,
	[Id] varchar (100) NULL
) ON [PRIMARY]

CREATE TABLE [dbo].[Items] (
	[Title] varchar (500) NULL,
	[Link] varchar (500) NULL,
	[Description] varchar (500) NULL,
	[RdfAbout] varchar (500) NULL
) ON [PRIMARY]


INSERT INTO [dbo].[Channel] ([Title],[Link],[Description],[Language]) VALUES ('Web 2.0 Tools for .NET Developers','http://www.web2.0tools.net','Supports versions 0.90, 0.91, 0.92, 2.0 and RDF (1.0) with all constructs. Complete integration with Visual Studio.NET 2003, Visual Studio 2005, and Visual Web Developer. All underlying functions, including parsing, manipulating, and creating XML elements and attributes is handled internally by the library.','en-us')

INSERT INTO [dbo].[Feed] ([Title],[Link],[Updated],[Author],[Id]) VALUES ('Web 2.0 Tools for .NET Developers','http://www.web2.0tools.net','2006-08-23 00:00:00.00','Web20Tools','http://www.web20tools.net')


INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('PS I want all the rights','http://dx.doi.org/10.1038/442118a','2006-08-23 00:00:00.00','Stakes raised in open-access debate','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('Making the paper John Donoghue','http://dx.doi.org/10.1038/7099xiiia','2006-08-23 00:00:00.00','A link between mind and machine that can turn thought into movement','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('Abstractions','http://dx.doi.org/10.1038/7099xiiib','2006-08-23 00:00:00.00','Senior authorMuch of the planets atmospheric methane comes from bogs, swamps and marshes. In these inhospitable climes, single-celled organisms called methanogens produce huge quantities of the greenhouse gas. But finding out more about these organisms is hard, as they are difficult to culture in','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('Correction','http://dx.doi.org/10.1038/7099xiiic','2006-08-23 00:00:00.00','In last weeks Author Page, the wrong photograph accompanied the article on Paul Segall (Nature442, xi 200610.1038/7098xia). The correct image is on the right. Nature apologizes for the error','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('Peer-review trial and debate','http://dx.doi.org/10.1038/7099xiiid','2006-08-23 00:00:00.00','Natures peer-review trial began at the start of last month. Authors whose manuscripts are sent for peer review can choose to have their submissions posted on a preprint server for open comments, in parallel with the conventional peer-review process. Anyone in the field can','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('Is this the bionic man?','http://dx.doi.org/10.1038/442109a','2006-08-23 00:00:00.00','Systems that allow a brain to control a computer are inching ever closer to reality - but their most important applications may be different from those envisaged by science fiction','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('Building bridges','http://dx.doi.org/10.1038/442110a','2006-08-23 00:00:00.00','An American geneticist advocates a rapprochement with religion','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('The beautiful game','http://dx.doi.org/10.1038/442110b','2006-08-23 00:00:00.00','Punditry took a hiding in Germany','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('Research highlights','http://dx.doi.org/10.1038/442112a','2006-08-23 00:00:00.00','Cell biology: Central oasis in gene desertJ. Cell Biol.. doi:10.1083/jcb.200603083 (2006)Mammalian chromosomes contain gene-rich clusters scattered along stretches of barren. A recent study addresses how these seemingly desultory structures may be associated with the three-dimensional arrangement of chromosomes within the','http://www.web20tools.net','http://www.web20Tools.net')
INSERT INTO [dbo].[Entries] ([Title],[Link],[Updated],[Summary],[Id],[id1]) VALUES ('Genomics luminary weighs in on US faith debate','http://dx.doi.org/10.1038/442114b','2006-08-23 00:00:00.00','Top geneticist asks the God question','http://www.web20tools.net','http://www.web20Tools.net')


INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('PS I want all the rights','http://dx.doi.org/10.1038/442118a','Stakes raised in open-access debate','http://dx.doi.org/10.1038/442118a')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('Making the paperJohn Donoghue','http://dx.doi.org/10.1038/7099xiiia','A link between mind and machine that can turn thought into movement','http://dx.doi.org/10.1038/7099xiiia')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('Abstractions','http://dx.doi.org/10.1038/7099xiiib','Senior authorMuch of the planets atmospheric methane comes from bogs, swamps and marshes. In these inhospitable climes, single-celled organisms called methanogens produce huge quantities of the greenhouse gas. But finding out more about these organisms is hard, as they are difficult to culture in','http://dx.doi.org/10.1038/7099xiiib')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('Correction','http://dx.doi.org/10.1038/7099xiiic','In last weeks Author Page, the wrong photograph accompanied the article on Paul Segall (Nature442, xi 200610.1038/7098xia). The correct image is on the right. Nature apologizes for the error','http://dx.doi.org/10.1038/7099xiiic')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('Peer-review trial and debate','http://dx.doi.org/10.1038/7099xiiid','Natures peer-review trial began at the start of last month. Authors whose manuscripts are sent for peer review can choose to have their submissions posted on a preprint server for open comments, in parallel with the conventional peer-review process. Anyone in the field can','http://dx.doi.org/10.1038/7099xiiid')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('Is this the bionic man?','http://dx.doi.org/10.1038/442109a','Systems that allow a brain to control a computer are inching ever closer to reality - but their most important applications may be different from those envisaged by science fiction','http://dx.doi.org/10.1038/442109a')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('Building bridges','http://dx.doi.org/10.1038/442110a','An American geneticist advocates a rapprochement with religion','http://dx.doi.org/10.1038/442110a')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('The beautiful game','http://dx.doi.org/10.1038/442110b','Punditry took a hiding in Germany','http://dx.doi.org/10.1038/442110b')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('Research highlights','http://dx.doi.org/10.1038/442112a','Cell biology: Central oasis in gene desertJ. Cell Biol.. doi:10.1083/jcb.200603083 (2006)Mammalian chromosomes contain gene-rich clusters scattered along stretches of barren, gene-poor. A recent study addresses how these seemingly desultory structures may be associated with the three-dimensional arrangement of chromosomes within the','http://dx.doi.org/10.1038/442112a')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('Genomics luminary weighs in on US faith debate','http://dx.doi.org/10.1038/442114b','Top geneticist asks the God question','http://dx.doi.org/10.1038/442114b')
INSERT INTO [dbo].[Items] ([Title],[Link],[Description],[RdfAbout]) VALUES ('SnapshotDeep-sea wonders','http://dx.doi.org/10.1038/442116a','From the whimsical to the downright scary, images featuring creatures from the deep are showcased in the BP Kongsberg Underwater Image Competition being held this week at the 11th International Deep-Sea Biology Symposium, UK. Narelle Towie takes a look at some of the most striking entries','http://dx.doi.org/10.1038/442116a')
