/* 
  	* AtomCombine.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.
*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Web20Tools.Feed.Atom; 
using Web20Tools.Security;  
using System.Resources; 
using System.Reflection; 
using Web20Tools.Feed;
using Web20Tools.ExceptionFramework;

namespace Samples.Atom
{
	/// <summary>
	/// Read multiple ATOM feeds and aggregate into a single feed (filtered)
	/// </summary>
	public class AtomCombine : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm Form1;
        protected System.Web.UI.WebControls.Label lblCreated;
        protected System.Web.UI.WebControls.HyperLink hlOpenXMLTop;
        protected System.Web.UI.WebControls.RadioButton rdddl;
        protected System.Web.UI.WebControls.DropDownList ddlUrls;
        protected System.Web.UI.WebControls.RadioButton rdtxt;
        protected System.Web.UI.WebControls.TextBox txtEnterUrl;
        protected System.Web.UI.WebControls.Button btnAddUrls;
        protected System.Web.UI.WebControls.Button btnRemove;
        protected System.Web.UI.WebControls.ListBox lbURL;
        protected System.Web.UI.WebControls.TextBox txtchTitle;
        protected System.Web.UI.WebControls.TextBox txtchLink;
        protected System.Web.UI.WebControls.TextBox txtchFeedId;
        protected System.Web.UI.WebControls.TextBox txtchAuthor;
        protected System.Web.UI.WebControls.DropDownList ddlitem;
        protected System.Web.UI.WebControls.DropDownList ddloption;
        protected System.Web.UI.WebControls.TextBox txtKeyword;
        protected System.Web.UI.WebControls.Button btnAggregate;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.Label lblCreatedBottom;
        protected System.Web.UI.WebControls.HyperLink hlOpenXML;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;

		protected System.Web.UI.WebControls.Button btnNext;

	    private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly());
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
			if(!IsPostBack)
			{
				FillUrls(); 
				txtEnterUrl.Enabled = false;
				rdddl.Checked = true; 
				rdddl.Attributes.Add("OnClick","return EnableDisable();");
				rdtxt.Attributes.Add("OnClick","return EnableDisable();");
				btnAddUrls.Attributes.Add("OnClick","return AddUrls();");
				btnAggregate.Attributes.Add("OnClick","return Aggregate();");
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void FillUrls()
		{
            ddlUrls.Items.Clear();
			ddlUrls.Items.Add(new ListItem(stringManager.GetString("strAtom03Url"),stringManager.GetString("strAtom03Url")) );
			ddlUrls.Items.Add(new ListItem(stringManager.GetString("strAtom10Url"),stringManager.GetString("strAtom10Url")) );

            ddlitem.Items.Clear();
			ddlitem.Items.Add(new ListItem("Title","Title"));
			ddlitem.Items.Add(new ListItem("Content","Content"));

            ddloption.Items.Clear();
			ddloption.Items.Add(new ListItem("StartsWith","StartsWith") );
			ddloption.Items.Add(new ListItem("EndsWith","EndsWith") );
			ddloption.Items.Add(new ListItem("Contains","Contains") );
			ddloption.Items.Add(new ListItem("Equals","Equals") );
			ddloption.Items.Add(new ListItem("Not Equals","NotEquals") );
		}

		protected void btnAggregate_Click(object sender, System.EventArgs e)
		{		
			LoadFeeds();
		}

		private void LoadFeeds()
		{
			try
			{
                License.LoadLicense();
				AtomFeed10 feed = new AtomFeed10();			
  
				for(int i =0; i<lbURL.Items.Count; i++)
				{
					AtomFeed tempfeed = AtomFeed.Load(lbURL.Items[i].Value);   
					AtomFeed10 feed10;
					if(tempfeed.Version == AtomVersion.Atom03)
					{
						AtomFeed03 feed03 = (AtomFeed03)tempfeed;
						feed10 = feed03.Convert(AtomVersion.Atom10); 
					}
					else
					{
						feed10 = (AtomFeed10)tempfeed;
					}
				 
					foreach(AtomEntry10 entry10 in feed10.Entries)
					{
						if(ApplyConstraint(entry10))
						{
							if(entry10.Id == DefaultValues.FeedUri)
							{
								entry10.Id = new FeedUri(txtchFeedId.Text);
							}
							feed.Entries.Add(entry10);  
						}
					}
				}	
					AtomLink feedLink = new AtomLink();
                    if (!txtchLink.Text.ToUpper().StartsWith("http://".ToUpper()))
                        txtchLink.Text = "http://" + txtchLink.Text;
					feedLink.HRef = new FeedUri(txtchLink.Text);
					feed.Links.Add(feedLink);
                    if (!txtchFeedId.Text.ToUpper().StartsWith("http://".ToUpper()))
                        txtchFeedId.Text = "http://" + txtchFeedId.Text;
				    feed.Id = new FeedUri(txtchFeedId.Text);

					AtomContentConstruct objFeedTitle = new AtomContentConstruct("title",txtchTitle.Text);
					feed.Title = objFeedTitle;

					AtomPersonConstruct objAuthor = new AtomPersonConstruct();
					objAuthor.Name = txtchAuthor.Text;

					AtomDateConstruct objFeedUpdated = new AtomDateConstruct();
					objFeedUpdated.DateTime = Convert.ToDateTime(DateTime.Now);
					feed.Updated = objFeedUpdated;
					feed.Authors.Add(objAuthor);
					
					if(feed.Entries.Count != 0 )
					{
						Session.Add("AtomFeed",feed); 
								
						lblCreated.Text = stringManager.GetString("strCreated") ;
						lblCreatedBottom.Text =  stringManager.GetString("strCreated");
						hlOpenXML.Text =  stringManager.GetString("strClick");
					
						hlOpenXMLTop.Text =  stringManager.GetString("strClick"); 
						hlOpenXML.NavigateUrl = "AtomShowFeed.aspx";
						hlOpenXMLTop.NavigateUrl = "AtomShowFeed.aspx"; 
						hlOpenXML.Target = "_blank";
						hlOpenXMLTop.Target = "_blank"; 
						lblMsg.Text = stringManager.GetString("strBlank");
					}
					else
					{
						lblCreated.Text = stringManager.GetString("strBlank");
						lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
						hlOpenXML.Text = stringManager.GetString("strBlank");
						hlOpenXMLTop.Text = stringManager.GetString("strBlank");
						lblMsg.Text = stringManager.GetString("strNoMatch"); 
					}
                    hlViewError.Text = stringManager.GetString("strBlank");
                    hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                    lblError.Text = stringManager.GetString("strBlank");
			}
			catch (InvalidLicenseException ilex) 
			{
				lblMsg.Text = stringManager.GetString("strLicenseException");
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLTop.Text = stringManager.GetString("strBlank");
				Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
			}
            catch (InvalidLicenseInfoException iliex)
            {
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");
                lblCreated.Text = stringManager.GetString("strBlank");
                lblCreatedBottom.Text = stringManager.GetString("strBlank");
                hlOpenXML.Text = stringManager.GetString("strBlank");
                hlOpenXMLTop.Text = stringManager.GetString("strBlank");
                Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }
			catch(Exception ex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLTop.Text = stringManager.GetString("strBlank");
								
				lblMsg.Text = stringManager.GetString("strErrorCreating") ;
				Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}

		protected void btnAddUrls_Click(object sender, System.EventArgs e)
		{
			if(rdddl.Checked == true )
			{
				lbURL.Items.Add(ddlUrls.SelectedValue); 
				txtEnterUrl.Enabled = false;
				ddlUrls.Enabled = true;;
			}
			else if(rdtxt.Checked == true)
			{
                if (!txtEnterUrl.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtEnterUrl.Text = "http://" + txtEnterUrl.Text;

				lbURL.Items.Add(txtEnterUrl.Text);
				ddlUrls.Enabled = false;
				txtEnterUrl.Enabled = true;
				txtEnterUrl.Text = stringManager.GetString("strHttp");
				
			}
			lblMsg.Text = stringManager.GetString("strBlank");
			lblCreated.Text = stringManager.GetString("strBlank");
			lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
			hlOpenXML.Text = stringManager.GetString("strBlank");
			hlOpenXMLTop.Text = stringManager.GetString("strBlank");
            hlViewError.Text = stringManager.GetString("strBlank");
		}
		
		private string FilterItem()
		{
			string filterentry = stringManager.GetString("strBlank");		
			
			switch(ddlitem.SelectedValue.ToLower())
			{
				case "title":
					filterentry= "title";
					break;
				case "content":
					filterentry= "content";
					break;
				case "link":
					filterentry= "link";
					break;
			}
			return filterentry; 
		}
				
		private string FilterOperation()
		{
			string filtertype = stringManager.GetString("strBlank");
			switch(ddloption.SelectedValue.ToLower())
			{
				case "startswith":
					filtertype="startswith";
					break;
				case "endswith":
					filtertype = "endswith";
					break;
				case "contains":
					filtertype = "contains";
					break;
				case "equals":
					filtertype ="equals";
					break;
				case "notequals":
					filtertype ="notequals";
					break;
			}
			return filtertype;
		}
		
		private bool ApplyConstraint(AtomEntry10 entry)
		{
			if(txtKeyword.Text.Length == 0)
			{ 
				return true;
			}
			else
			{
				string item;
				string operation;
				
				item = FilterItem();
				operation = FilterOperation();
				
				if(item == "title")
				{
					if(operation == "startswith")
					{
						if(entry.Title.Content.Trim().ToLower().StartsWith(txtKeyword.Text.Trim().ToLower()))
							return true;
						else
							return false;
					}
					if(operation == "endswith")
					{
						if(entry.Title.Content.Trim().ToLower().EndsWith(txtKeyword.Text.Trim().ToLower()))
							return true;
						else
							return false;
					}
					if(operation == "contains")
					{
						if(entry.Title.Content.Trim().ToLower().IndexOf(txtKeyword.Text.Trim().ToLower()) == -1)
							return false;
						else
							return true;
					}
					if(operation == "equals")
					{
						if (string.Compare(entry.Title.Content.Trim(),txtKeyword.Text.Trim(), true, System.Globalization.CultureInfo.CurrentCulture) == 0)  
							return true;
						else
							return false;
					}
					if(operation == "notequals")
					{
						if (string.Compare(entry.Title.Content,txtKeyword.Text.Trim(), true, System.Globalization.CultureInfo.CurrentCulture) == -1)  
							return true;
						else
							return false;
					}
				}

				if(item == "content")
				{
					if(operation == "startswith")
					{
						if(entry.Summary.Content.Trim().ToLower().StartsWith(txtKeyword.Text.Trim().ToLower()))
							return true;
						else
							return false;
					}
					if(operation == "endswith")
					{
						if(entry.Summary.Content.Trim().ToLower().EndsWith(txtKeyword.Text.Trim().ToLower()))
							return true;
						else
							return false;
					}
					if(operation == "contains")
					{
						if(entry.Summary.Content.Trim().ToLower().IndexOf(txtKeyword.Text.Trim().ToLower()) == -1)
							return false;
						else
							return true;
					}
					if(operation == "equals")
					{
						if (string.Compare(entry.Summary.Content.Trim(), txtKeyword.Text.Trim(), true, System.Globalization.CultureInfo.CurrentCulture) == 0)  
							return true;
						else
							return false;
					}
					if(operation == "notequals")
					{
						if (string.Compare(entry.Summary.Content.Trim(), txtKeyword.Text.Trim(), true, System.Globalization.CultureInfo.CurrentCulture) == -1)  
							return true;
						else
							return false;
					}
				}
			}
			return false;
		}

		protected void btnRemove_Click(object sender, System.EventArgs e)
		{
			if(lbURL.SelectedIndex > -1)
				lbURL.Items.Remove(lbURL.SelectedItem);   
			lblMsg.Text = stringManager.GetString("strBlank");
            lblCreated.Text = stringManager.GetString("strBlank");
            lblCreatedBottom.Text = stringManager.GetString("strBlank");
            hlOpenXML.Text = stringManager.GetString("strBlank");
            hlOpenXMLTop.Text = stringManager.GetString("strBlank");
            hlViewError.Text = stringManager.GetString("strBlank");
		}
	}
}
