/* 
  	* AtomConvert.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.
*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Web20Tools.Feed.Atom;
using System.Reflection;
using System.Resources;
using Web20Tools.Security;
using Web20Tools.ExceptionFramework; 

namespace Samples.Atom
{
	/// <summary>
	/// Convert an ATOM feed.
	/// </summary>
	public class AtomConvert : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm Form1;
        protected System.Web.UI.WebControls.Label lblCreated;
        protected System.Web.UI.WebControls.HyperLink hlOpenXMLtop;
        protected System.Web.UI.WebControls.RadioButton rdSelectUrl;
        protected System.Web.UI.WebControls.DropDownList ddlURL;
        protected System.Web.UI.WebControls.RadioButton rdEnterUrl;
        protected System.Web.UI.WebControls.TextBox txtURL;
        protected System.Web.UI.WebControls.Label lblConvertVer;
        protected System.Web.UI.WebControls.DropDownList ddlConvertVer;
        protected System.Web.UI.WebControls.Button btnLoad;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.Label lblCreatedBottom;
        protected System.Web.UI.WebControls.HyperLink hlOpenXML;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;

		private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly()); 
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			
			if(!IsPostBack)
			{
				fillURLs();
				txtURL.Enabled=false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked=true;
				rdSelectUrl.Attributes.Add("OnClick","return EnableDisableURLControls();");
				rdEnterUrl.Attributes.Add("OnClick","return EnableDisableURLControls();");
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
		}
		#endregion
		
		#region Load Button Event
		protected void btnLoad_Click(object sender, System.EventArgs e)
		{
			try
			{
                License.LoadLicense(); 
				LoadAttribute();
				Convert();

                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
			}
			catch (AtomReaderException ex) 
			{
				if(ex.Message == stringManager.GetString("strUnlicensed"))
					lblMsg.Text = stringManager.GetString("strLicenseException");
				else
					lblMsg.Text = ex.Message;
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
            catch (InvalidLicenseException ilex)
            {
                lblCreated.Text = stringManager.GetString("strBlank");
                lblCreatedBottom.Text = stringManager.GetString("strBlank");
                hlOpenXML.Text = stringManager.GetString("strBlank");
                hlOpenXMLtop.Text = stringManager.GetString("strBlank");
                lblMsg.Text = stringManager.GetString("strLicenseException");
                Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
            }
            catch (InvalidLicenseInfoException iliex)
            {
                lblCreated.Text = stringManager.GetString("strBlank");
                lblCreatedBottom.Text = stringManager.GetString("strBlank");
                hlOpenXML.Text = stringManager.GetString("strBlank");
                hlOpenXMLtop.Text = stringManager.GetString("strBlank");
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");
                Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError"); 
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }
			catch  (Exception ex) 
			{  
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank");
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strConvertError");
			    Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}
       #endregion Load Button Event

		#region Functions
		private void LoadAttribute()
		{
			btnLoad.Attributes.Add("OnClick","return checkURL();");
		}
		private void fillURLs()
		{
			ddlURL.Items.Add(new ListItem(stringManager.GetString("strAtom03Url"), stringManager.GetString("strAtom03Url")));
			ddlURL.Items.Add(new ListItem(stringManager.GetString("strAtom10Url"), stringManager.GetString("strAtom10Url")));
		}
        #endregion Functions

		#region ConvertFunction
		private void Convert()
		{
			string url=string.Empty;
			bool convert=false;

			if(rdSelectUrl.Checked == true)
			{
				url = ddlURL.SelectedValue;
			}
			if(rdEnterUrl.Checked == true)
			{
                if (!txtURL.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtURL.Text = "http://" + txtURL.Text;
				url = txtURL.Text;
			}
			AtomFeed feed = AtomFeed.Load(url);
			if(ddlConvertVer.SelectedValue == "0.3")
			{
				if(feed.Version != AtomVersion.Atom03)
				{
					AtomFeed10 feed10 = AtomFeed10.Load(url);
					AtomFeed03 feed03 = feed10.Convert(AtomVersion.Atom03);
					convert=true;
					lblMsg.Text=stringManager.GetString("strBlank");
					Session.Add("AtomFeed",feed03);		
				}
				else
				{
					lblMsg.Text = string.Format(stringManager.GetString("strFeedMsg"),"0.3");
					lblCreated.Text = stringManager.GetString("strBlank");
					lblCreatedBottom.Text = stringManager.GetString("strBlank");
					hlOpenXML.Text = stringManager.GetString("strBlank");
					hlOpenXMLtop.Text = stringManager.GetString("strBlank");
					Session["AtomFeed"] = null; 
				}
			}
			if(ddlConvertVer.SelectedValue == "1.0")
			{
				if(feed.Version != AtomVersion.Atom10)
				{
					AtomFeed03 feed03 = AtomFeed03.Load(url);
					AtomFeed10 feed10 = feed03.Convert(AtomVersion.Atom10);
					convert=true;
					lblMsg.Text=stringManager.GetString("strBlank");
					Session.Add("AtomFeed",feed10);
				}
				else
				{
					lblMsg.Text = string.Format(stringManager.GetString("strFeedMsg"),"1.0");
					lblCreated.Text = stringManager.GetString("strBlank");
					lblCreatedBottom.Text = stringManager.GetString("strBlank");
					hlOpenXML.Text = stringManager.GetString("strBlank");
					hlOpenXMLtop.Text = stringManager.GetString("strBlank");
					Session["AtomFeed"] = null; 
				}
			}
			if(convert == true)
			{
				lblCreated.Text = stringManager.GetString("strCreated");
				lblCreatedBottom.Text = stringManager.GetString("strCreated");
				hlOpenXML.Text = stringManager.GetString("strClick");
				hlOpenXMLtop.Text = stringManager.GetString("strClick");
				hlOpenXML.NavigateUrl = "AtomShowFeed.aspx";
				hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx";
				hlOpenXML.Target = "_blank";
				hlOpenXMLtop.Target = "_blank"; 
				lblMsg.Text = stringManager.GetString("strBlank");			
			}
		}
		#endregion ConvertFunction
	}
}
