/* 
  	* AtomCreate.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.
*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Xml;
using Web20Tools.Feed.Atom;
using Web20Tools.Security; 
using System.IO;
using System.Reflection;
using System.Resources;   
using Web20Tools.Feed;
using Web20Tools.ExceptionFramework;

namespace Samples.Atom
{
	/// <summary>
	/// Create an ATOM feed.
	/// </summary>
	public class AtomCreate : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm Form1;
        protected System.Web.UI.WebControls.Label lblCreated;
        protected System.Web.UI.WebControls.HyperLink hlOpenXMLtop;
        protected System.Web.UI.WebControls.DropDownList ddlVersions;
        protected System.Web.UI.WebControls.TextBox txtFeedTitle;
        protected System.Web.UI.WebControls.TextBox txtFeedLinkHref;
        protected System.Web.UI.WebControls.Label lblFeedModify;
        protected System.Web.UI.WebControls.TextBox txtFeedModified;
        protected System.Web.UI.WebControls.TextBox txtFeedAuthorName;
        protected System.Web.UI.WebControls.TextBox txtFeedId;
        protected System.Web.UI.WebControls.TextBox txtEntryTitle;
        protected System.Web.UI.WebControls.TextBox txtEntryLinkHref;
        protected System.Web.UI.WebControls.Label lblEntryId;
        protected System.Web.UI.WebControls.Label lblColon;
        protected System.Web.UI.WebControls.TextBox txtEntryId;
        protected System.Web.UI.WebControls.Label lblEntryModify;
        protected System.Web.UI.WebControls.TextBox txtEntryModified;
        protected System.Web.UI.WebControls.Label lblEntryIssue;
        protected System.Web.UI.WebControls.TextBox txtEntryIssued;
        protected System.Web.UI.WebControls.TextBox txtEntrySummary;
        protected System.Web.UI.WebControls.Button btnSave;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.Label lblCreatedBottom;
        protected System.Web.UI.WebControls.HyperLink hlOpenXML;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;

		protected System.Web.UI.WebControls.Button btnModified03;
		private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly()); 
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
			if(!IsPostBack)
			{
				ddlVersions.Attributes.Add("OnChange","return clearLables();");
				ddlVersions.Attributes.Add("OnChange","return showVersionDiv();");				
				loadDefaultValues();
				fillVersions();
				btnSave.Attributes.Add("OnClick","return clearLables();");
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
#if(VS8)
                ClientScript.RegisterStartupScript(Type.GetType("System.String"), "Start", "<script language=JavaScript>showVersionDiv();</script>");  
#else
                RegisterStartupScript("Start","<script language=JavaScript>showVersionDiv();</script>");				
#endif
			}									
		}

		private void loadDefaultValues()
		{
			txtFeedTitle.Text = stringManager.GetString("strFeedTitle");
            txtFeedLinkHref.Text = stringManager.GetString("strFeedLink");
			txtFeedModified.Text = "08/01/2006";
			txtFeedAuthorName.Text = stringManager.GetString("strAuthor");
			txtFeedId.Text = stringManager.GetString("strFeedLink");
			txtEntryTitle.Text = stringManager.GetString("strEntryTitle");
			txtEntryLinkHref.Text = "http://www.web20tools.net/Products/Atom_Library/Features.aspx";
			txtEntryModified.Text = "08/01/2006";
			txtEntryIssued.Text = "08/01/2006";
			txtEntryId.Text = stringManager.GetString("strFeedLink");
			txtEntrySummary.Text = stringManager.GetString("strContent");
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
		}
		#endregion

		#region Private Methods
		private void fillVersions()
		{
			ddlVersions.Items.Add("Atom 0.3");
			ddlVersions.Items.Add("Atom 1.0");
		}
		#endregion

		protected void btnSave_Click(object sender, System.EventArgs e)
		{
			if(ddlVersions.SelectedItem.Text == "Atom 0.3")
			{
				saveAtom03();
			}
			else
			{
				saveAtom10();
			}
#if(VS8)
            ClientScript.RegisterStartupScript(Type.GetType("System.String"), "Start", "<script language=JavaScript>showVersion();</script>");  
#else
			RegisterStartupScript("Start","<script language=JavaScript>showVersion();</script>");
#endif
		}
		
		private void saveAtom03()
		{
			try
			{
                License.LoadLicense();
				AtomFeed03 objAtomFeed03 = new AtomFeed03();
				AtomEntry03 objAtomEntry03 = new AtomEntry03();
			
				AtomContentConstruct objFeedTitle = new AtomContentConstruct("title",txtFeedTitle.Text);
				objAtomFeed03.Title = objFeedTitle;
			
				AtomLink feedLink = new AtomLink();
                if (!txtFeedLinkHref.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtFeedLinkHref.Text = "http://" + txtFeedLinkHref.Text;
				feedLink.HRef = new FeedUri(txtFeedLinkHref.Text);
				objAtomFeed03.Links.Add(feedLink);

                if (!txtFeedId.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtFeedId.Text = "http://" + txtFeedId.Text;

				objAtomFeed03.Id = new FeedUri(txtFeedId.Text);

				AtomDateConstruct objFeedModified = new AtomDateConstruct();
				DateTime tempDate = Convert.ToDateTime(txtFeedModified.Text, System.Globalization.CultureInfo.CurrentCulture);
				objFeedModified.DateTime = tempDate ;
				objAtomFeed03.Modified= objFeedModified;

				AtomPersonConstruct objAuthor = new AtomPersonConstruct();
				objAuthor.Name = txtFeedAuthorName.Text;
				objAtomFeed03.Author = objAuthor;

				AtomContentConstruct objEntryTitle = new AtomContentConstruct("title",txtEntryTitle.Text);
				objAtomEntry03.Title = objEntryTitle;
			            
				AtomLink entryLink = new AtomLink();
                if (!txtEntryLinkHref.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtEntryLinkHref.Text = "http://" + txtEntryLinkHref.Text;
				entryLink.HRef = new FeedUri(txtEntryLinkHref.Text);
				objAtomEntry03.Links.Add(entryLink);

				AtomDateConstruct objEntryModified = new AtomDateConstruct();
				objEntryModified.DateTime = Convert.ToDateTime(txtEntryModified.Text, System.Globalization.CultureInfo.CurrentCulture);
				objAtomEntry03.Modified = objEntryModified;
			
				AtomDateConstruct objEntryIssued = new AtomDateConstruct("issued",Convert.ToDateTime(txtEntryIssued.Text, System.Globalization.CultureInfo.CurrentCulture));
				objAtomEntry03.Issued = objEntryIssued;

				objAtomFeed03.Entries.Add(objAtomEntry03);

				Session.Add("AtomFeed", objAtomFeed03); 
						
				lblCreated.Text = stringManager.GetString("strCreated");
				lblCreatedBottom.Text = stringManager.GetString("strCreated"); 
				hlOpenXML.Text = stringManager.GetString("strClick");
				hlOpenXMLtop.Text = stringManager.GetString("strClick");
				hlOpenXML.NavigateUrl = "AtomShowFeed.aspx";
				hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx";
				hlOpenXML.Target = "_blank";
				hlOpenXMLtop.Target = "_blank";
				lblMsg.Text = stringManager.GetString("strBlank");

                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
			}
			catch (InvalidLicenseException ilex) 
			{
				lblMsg.Text = stringManager.GetString("strLicenseException");
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
			}
            catch (InvalidLicenseInfoException iliex)
            {
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");
                lblCreated.Text = stringManager.GetString("strBlank");
                lblCreatedBottom.Text = stringManager.GetString("strBlank");
                hlOpenXML.Text = stringManager.GetString("strBlank");
                hlOpenXMLtop.Text = stringManager.GetString("strBlank");
                Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }	
			catch(Exception ex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strErrorCreating");
				Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}

		private void saveAtom10()
		{
			try
			{
                License.LoadLicense();
				AtomFeed10 objAtomFeed10 = new AtomFeed10();
				AtomEntry10 objAtomEntry10 = new AtomEntry10();
			
				AtomContentConstruct objFeedTitle = new AtomContentConstruct("title",txtFeedTitle.Text);
				objAtomFeed10.Title = objFeedTitle;

                if (!txtFeedId.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtFeedId.Text = "http://" + txtFeedId.Text;
				objAtomFeed10.Id = new FeedUri(txtFeedId.Text);
			
				AtomLink feedLink = new AtomLink();
                if (!txtFeedLinkHref.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtFeedLinkHref.Text = "http://" + txtFeedLinkHref.Text;
				feedLink.HRef = new FeedUri(txtFeedLinkHref.Text);
				objAtomFeed10.Links.Add(feedLink);

				AtomDateConstruct objFeedUpdated = new AtomDateConstruct("updated",Convert.ToDateTime(txtFeedModified.Text,System.Globalization.CultureInfo.CurrentCulture));
				
				objAtomFeed10.Updated = objFeedUpdated;

				AtomPersonConstruct objAuthor = new AtomPersonConstruct();
				objAuthor.Name = txtFeedAuthorName.Text;
			
				objAtomFeed10.Authors.Add(objAuthor);

				AtomContentConstruct objEntryTitle = new AtomContentConstruct("title",txtEntryTitle.Text);
				objAtomEntry10.Title = objEntryTitle;

				AtomLink entryLink = new AtomLink();
                if (!txtEntryLinkHref.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtEntryLinkHref.Text = "http://" + txtEntryLinkHref.Text;
				entryLink.HRef = new FeedUri(txtEntryLinkHref.Text);
				objAtomEntry10.Links.Add(entryLink);

				AtomDateConstruct objEntryUpdated = new AtomDateConstruct("updated",Convert.ToDateTime(txtEntryModified.Text,System.Globalization.CultureInfo.CurrentCulture));
				
				objAtomEntry10.Updated = objEntryUpdated;

                if (!txtEntryId.Text.ToUpper().StartsWith("http://".ToUpper()))
                    txtEntryId.Text = "http://" + txtEntryId.Text;

				objAtomEntry10.Id = new FeedUri(txtEntryId.Text);
			
				objAtomFeed10.Entries.Add(objAtomEntry10);

				AtomContentConstruct objEntrySummary = new AtomContentConstruct("summary",txtEntrySummary.Text);
				objAtomEntry10.Summary = objEntrySummary;

				Session.Add("AtomFeed",objAtomFeed10); 
			
				lblCreated.Text = stringManager.GetString("strCreated");
				lblCreatedBottom.Text = stringManager.GetString("strCreated");
				hlOpenXML.Text = stringManager.GetString("strClick");
				hlOpenXMLtop.Text = stringManager.GetString("strClick"); 
				hlOpenXML.NavigateUrl = "AtomShowFeed.aspx";
				hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx"; 
				hlOpenXML.Target = "_blank";
				hlOpenXMLtop.Target = "_blank"; 
				lblMsg.Text = stringManager.GetString("strBlank");

                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
			}
			catch (InvalidLicenseException ilex) 
			{
				lblMsg.Text = stringManager.GetString("strLicenseException");
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
			}
            catch (InvalidLicenseInfoException iliex)
            {
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");
                lblCreated.Text = stringManager.GetString("strBlank");
                lblCreatedBottom.Text = stringManager.GetString("strBlank");
                hlOpenXML.Text = stringManager.GetString("strBlank");
                hlOpenXMLtop.Text = stringManager.GetString("strBlank");
                Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }
			catch(Exception ex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strErrorCreating");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}

	}
}
