/* 
  	* AtomFeedDataset.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.
*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using Web20Tools.Feed.Atom;
using Web20Tools.Security; 
using System.Reflection;
using System.Resources; 
using Web20Tools.Feed;
using Web20Tools.ExceptionFramework;      

namespace Samples.Atom
{
	/// <summary>
	/// Create an ATOM Feed from a DataSet.
	/// </summary>
	public class AtomFeedDataset : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm Form1;
        protected System.Web.UI.WebControls.Label lblCreated;
        protected System.Web.UI.WebControls.HyperLink hlOpenXMLtop;
        protected System.Web.UI.WebControls.DropDownList ddlVersions;
        protected System.Web.UI.WebControls.TextBox txtConnection;
        protected System.Web.UI.WebControls.TextBox txtFeedQuery;
        protected System.Web.UI.WebControls.TextBox txtEntriesQuery;
        protected System.Web.UI.WebControls.Button btnSave;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.Label lblCreatedBottom;
        protected System.Web.UI.WebControls.HyperLink hlOpenXML;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;

	    private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly()); 
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here

            if (!IsPostBack)
            {
                loadAttributes();
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
            }
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    

		}
		#endregion

		private void fillVersions()
		{
			ddlVersions.Items.Add("Atom 0.3");
			ddlVersions.Items.Add("Atom 1.0");
		}

		private void loadAttributes()
		{
			fillVersions();
			ddlVersions.Attributes.Add("OnChange","changeDropdown();");  
			txtConnection.Text = stringManager.GetString("strConnectionString");
			txtFeedQuery.Text = stringManager.GetString("strFeedQuery");
			txtEntriesQuery.Text = stringManager.GetString("strEntryQuery");
		}

		protected void btnSave_Click(object sender, System.EventArgs e)
		{
			try
			{
                License.LoadLicense(); 
				//Fill DataSet From DataBase
				SqlConnection con = new SqlConnection(txtConnection.Text);
				con.Open();
				SqlDataAdapter sqlAdp = new SqlDataAdapter(txtFeedQuery.Text,con);
				DataSet dsFeed = new DataSet();
				dsFeed.Locale = System.Globalization.CultureInfo.InvariantCulture;    
				sqlAdp.Fill(dsFeed);
				sqlAdp = new SqlDataAdapter(txtEntriesQuery.Text,con);
				DataSet dsEntry = new DataSet();
				dsEntry.Locale = System.Globalization.CultureInfo.InvariantCulture;    
				sqlAdp.Fill(dsEntry);
                 				
				if(ddlVersions.SelectedItem.Text.Equals("Atom 1.0"))
				{
					saveAtom10(dsFeed,dsEntry);
				}
				else
				{
					saveAtom03(dsFeed,dsEntry);
			    }

                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
			}
			catch (InvalidLicenseException ilex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank");
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strLicenseException");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
			}
            catch (InvalidLicenseInfoException iliex)
            {
                lblCreated.Text = stringManager.GetString("strBlank");
                lblCreatedBottom.Text = stringManager.GetString("strBlank");
                hlOpenXML.Text = stringManager.GetString("strBlank");
                hlOpenXMLtop.Text = stringManager.GetString("strBlank");
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }
			catch(Exception ex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank");
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strErrorCreating") ;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}

		private void saveAtom10(DataSet dsFeed, DataSet dsEntry)
		{
			try
			{
				AtomFeed10 objAtomFeed10 = new AtomFeed10();
				AtomLink feedLink = new AtomLink();
				AtomPersonConstruct objAuthor = new AtomPersonConstruct();
				AtomDateConstruct objFeedUpdated = new AtomDateConstruct();

				for(int i=0;i<dsFeed.Tables[0].Rows.Count;i++)
				{
					AtomContentConstruct objFeedTitle = new AtomContentConstruct("Title",dsFeed.Tables[0].Rows[0]["Title"].ToString());
					objAtomFeed10.Title = objFeedTitle;

					feedLink.HRef = new FeedUri(dsFeed.Tables[0].Rows[0]["Link"].ToString());
					objAtomFeed10.Links.Add(feedLink);

					objFeedUpdated.DateTime = Convert.ToDateTime(dsFeed.Tables[0].Rows[0]["Updated"].ToString(), System.Globalization.CultureInfo.CurrentCulture);
					objAtomFeed10.Updated = objFeedUpdated;

					objAuthor.Name = dsFeed.Tables[0].Rows[0]["Author"].ToString();
					objAtomFeed10.Authors.Add(objAuthor);

					Web20Tools.Feed.FeedUri uri=new FeedUri(dsFeed.Tables[0].Rows[0]["Id"].ToString());
					objAtomFeed10.Id = uri;
				}
				
				for(int i=0;i<dsEntry.Tables[0].Rows.Count;i++)
				{
					AtomEntry10 objAtomEntry10 = new AtomEntry10();
				
					AtomContentConstruct objEntryTitle = new AtomContentConstruct("Title",dsEntry.Tables[0].Rows[i]["Title"].ToString());
					objAtomEntry10.Title = objEntryTitle;

					AtomLink entryLink = new AtomLink();
					entryLink.HRef = new FeedUri(dsEntry.Tables[0].Rows[i]["Link"].ToString());
					objAtomEntry10.Links.Add(entryLink);   

					objFeedUpdated.DateTime = Convert.ToDateTime(dsEntry.Tables[0].Rows[i]["Updated"].ToString());
					objAtomEntry10.Updated = objFeedUpdated;

					AtomContentConstruct objEntrySummary = new AtomContentConstruct("summary",dsEntry.Tables[0].Rows[i]["Summary"].ToString());
					objAtomEntry10.Summary = objEntrySummary;

					Web20Tools.Feed.FeedUri uri=new FeedUri(dsEntry.Tables[0].Rows[0]["Id"].ToString());
					objAtomEntry10.Id = uri;

					objAtomFeed10.Entries.Add(objAtomEntry10);
				}
											
				Session.Add("AtomFeed",objAtomFeed10);
			
				lblCreated.Text = stringManager.GetString("strCreated");
				lblCreatedBottom.Text = stringManager.GetString("strCreated");
				hlOpenXML.Text = stringManager.GetString("strClick");
				hlOpenXMLtop.Text = stringManager.GetString("strClick"); 
				hlOpenXML.NavigateUrl = "AtomShowFeed.aspx";
				hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx"; 
				hlOpenXML.Target = "_blank";
				hlOpenXMLtop.Target = "_blank"; 
				lblMsg.Text = stringManager.GetString("strBlank");

                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
			}
			catch (InvalidLicenseException ilex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strLicenseException");
				Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
			}
			catch(Exception ex)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank"); 
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strErrorCreating");
				Session["AtomFeed"] = null;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}

		private void saveAtom03(DataSet dsFeed, DataSet dsEntry)
		{
			try
			{
				AtomFeed03 objAtomFeed03 = new AtomFeed03();				
				AtomLink feedLink = new AtomLink();
				AtomPersonConstruct objAuthor = new AtomPersonConstruct();
				AtomDateConstruct objFeedModified = new AtomDateConstruct();

				for(int i=0;i<dsFeed.Tables[0].Rows.Count;i++)
				{
					AtomContentConstruct objFeedTitle = new AtomContentConstruct("Title",dsFeed.Tables[0].Rows[0]["Title"].ToString());
					objAtomFeed03.Title = objFeedTitle;

					feedLink.HRef = new FeedUri(dsFeed.Tables[0].Rows[0]["Link"].ToString());
					objAtomFeed03.Links.Add(feedLink);

					objFeedModified.DateTime = Convert.ToDateTime(dsFeed.Tables[0].Rows[0]["Updated"].ToString());
					objAtomFeed03.Modified = objFeedModified;

					objAuthor.Name = dsFeed.Tables[0].Rows[0]["Author"].ToString();
					objAtomFeed03.Author = objAuthor;

					Web20Tools.Feed.FeedUri uri=new FeedUri(dsFeed.Tables[0].Rows[0]["Id"].ToString());
					objAtomFeed03.Id = uri;
				}
				
				for(int i=0;i<dsEntry.Tables[0].Rows.Count;i++)
				{
					AtomEntry03 objAtomEntry03 = new AtomEntry03();

					AtomContentConstruct objEntryTitle = new AtomContentConstruct("Title",dsEntry.Tables[0].Rows[i]["Title"].ToString());
					objAtomEntry03.Title = objEntryTitle;

					AtomLink entryLink = new AtomLink();
					entryLink.HRef = new FeedUri(dsEntry.Tables[0].Rows[i]["Link"].ToString());
					objAtomEntry03.Links.Add(entryLink);   

					objFeedModified.DateTime = Convert.ToDateTime(dsEntry.Tables[0].Rows[i]["Updated"].ToString());
					objAtomEntry03.Modified  = objFeedModified;

					objFeedModified.DateTime = Convert.ToDateTime(dsEntry.Tables[0].Rows[i]["Updated"].ToString());
					objAtomEntry03.Issued  = objFeedModified;

					AtomContentConstruct objEntrySummary = new AtomContentConstruct("summary",dsEntry.Tables[0].Rows[i]["Summary"].ToString());
					objAtomEntry03.Summary = objEntrySummary;

					Web20Tools.Feed.FeedUri uri=new FeedUri(dsEntry.Tables[0].Rows[0]["Id"].ToString());
					objAtomEntry03.Id =uri;

					objAtomFeed03.Entries.Add(objAtomEntry03);
				}
										
				Session.Add("AtomFeed",objAtomFeed03);
			
				lblCreated.Text = stringManager.GetString("strCreated");
				lblCreatedBottom.Text = stringManager.GetString("strCreated");
				hlOpenXML.Text = stringManager.GetString("strClick");
				hlOpenXMLtop.Text = stringManager.GetString("strClick");
				hlOpenXML.NavigateUrl = "AtomShowFeed.aspx";
				hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx"; 
				hlOpenXML.Target = "_blank";
				hlOpenXMLtop.Target = "_blank"; 
				lblMsg.Text = stringManager.GetString("strBlank");
			}
			catch(InvalidLicenseException)
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank");
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strLicenseException");
				Session["AtomFeed"] = null; 
			}
			catch
			{
				lblCreated.Text = stringManager.GetString("strBlank");
				lblCreatedBottom.Text = stringManager.GetString("strBlank");
				hlOpenXML.Text = stringManager.GetString("strBlank");
				hlOpenXMLtop.Text = stringManager.GetString("strBlank");
				lblMsg.Text = stringManager.GetString("strErrorCreating");
				Session["AtomFeed"] = null; 
			}
		}
		
	}
}
