/* 
  	* AtomLoad.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.
*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using Web20Tools.Feed.Atom;
using System.Reflection;
using System.Resources;  
using Web20Tools.Feed;
using Web20Tools.Security;
using System.Text;
using Web20Tools.ExceptionFramework; 

namespace Samples.Atom
{
	/// <summary>
	/// Read and display ATOM 0.3 and 1.0 feeds.
	/// </summary>
	public class AtomLoad : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm Form1;
        protected System.Web.UI.WebControls.RadioButton rdSelectUrl;
        protected System.Web.UI.WebControls.DropDownList ddlURL;
        protected System.Web.UI.WebControls.RadioButton rdEnterUrl;
        protected System.Web.UI.WebControls.TextBox txtURL;
        protected System.Web.UI.WebControls.Button btnLoad;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.Label lblFeed;
        protected System.Web.UI.WebControls.DataGrid dgAtomFeed;
        protected System.Web.UI.WebControls.Label lblEntry;
        protected System.Web.UI.WebControls.DataGrid dgEntry;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;

		protected AtomFeed03 feed03;		
		DataColumn colAttribute;
		DataColumn colValue;
		DataColumn colTag;
		DataRow dr;
		protected System.Web.UI.HtmlControls.HtmlAnchor lnk;
		DataTable dtAtomFeeds;
		private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly()); 

		#region Page Events
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
			if(!IsPostBack)
			{
				fillURLs();
				txtURL.Enabled=false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked=true;
				lblFeed.Text = stringManager.GetString("strBlank");
				lblEntry.Text = stringManager.GetString("strBlank");
				rdSelectUrl.Attributes.Add("OnClick","return EnableDiableURLControls();");
				rdEnterUrl.Attributes.Add("OnClick","return EnableDiableURLControls();");
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
			}
		}

		#endregion

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.dgAtomFeed.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.dgAtomFeed_ItemCreated);
			this.dgEntry.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.dgEntry_ItemCreated);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		#region Button Events
		protected void btnLoad_Click(object sender, System.EventArgs e)
		{
			btnLoad.Attributes.Add("OnClick","return checkURL();");
			AtomFeed feed;
			try
			{
                License.LoadLicense(); 
				if(rdSelectUrl.Checked)
				{
					feed = AtomFeed.Load(ddlURL.SelectedValue);
					ddlURL.Enabled =true;
					txtURL.Enabled=false;
					txtURL.Text = stringManager.GetString("strHttp");
				}
				else
				{
                    if (!txtURL.Text.ToUpper().StartsWith("http://".ToUpper()))
                        txtURL.Text = "http://" + txtURL.Text;
					feed = AtomFeed.Load(txtURL.Text);
					txtURL.Enabled=true;
					ddlURL.Enabled=false;
				}
				
				switch (feed.Version)
				{
					case AtomVersion.Atom03:
						dgAtomFeed.DataSource = DisplayFeed03((AtomFeed03)feed);
						dgAtomFeed.DataBind();
						dgEntry.DataSource = DisplayEntry03((AtomFeed03)feed);
						dgEntry.DataBind();
						break;
					case AtomVersion.Atom10:
						dgAtomFeed.DataSource = DisplayFeed10((AtomFeed10)feed);
						dgAtomFeed.DataBind();
						dgEntry.DataSource = DisplayEntry10((AtomFeed10)feed);
						dgEntry.DataBind();
						break;
				}
				lblFeed.Text = stringManager.GetString("strFeedGridTitle");
				lblEntry.Text = stringManager.GetString("strEntryGridTitle");
				dgAtomFeed.Visible = true;
				dgEntry.Visible = true;
				lblMsg.Text = stringManager.GetString("strBlank");
                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
				Response.Write("<script language=javascript>window.navigate('#bm');</script>");
			}
			catch (AtomReaderException ex)
			{              
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdEnterUrl.Checked = false;
				if(ex.Message == stringManager.GetString("strUnlicensed"))
					lblMsg.Text = stringManager.GetString("strLicenseException");
                lblMsg.Text = stringManager.GetString("strErrorReading");
				lblFeed.Text = stringManager.GetString("strBlank");
				lblEntry.Text = stringManager.GetString("strBlank");
                dgAtomFeed.Visible = false;
				dgEntry.Visible = false;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}  
            catch (InvalidLicenseException ilex)
			{              
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdEnterUrl.Checked = false;

                lblMsg.Text = stringManager.GetString("strLicenseException");
				lblFeed.Text = stringManager.GetString("strBlank");
				lblEntry.Text = stringManager.GetString("strBlank");
                dgAtomFeed.Visible = false;
				dgEntry.Visible = false;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
			}  
            catch(InvalidLicenseInfoException iliex)
			{              
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdEnterUrl.Checked = false;

                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");
				lblFeed.Text = stringManager.GetString("strBlank");
				lblEntry.Text = stringManager.GetString("strBlank");
                dgAtomFeed.Visible = false;
				dgEntry.Visible = false;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
			}  
			catch(Exception ex)
			{              
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdEnterUrl.Checked = false;

				lblMsg.Text = stringManager.GetString("strErrorReading") ;
				lblFeed.Text = stringManager.GetString("strBlank");
				lblEntry.Text = stringManager.GetString("strBlank");
                dgAtomFeed.Visible = false;
				dgEntry.Visible = false;

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}  
		}
		#endregion

		#region Feeds03
		public DataTable DisplayFeed03(AtomFeed03 feed03)
		{
			dtAtomFeeds = new DataTable();
			dtAtomFeeds.Locale = System.Globalization.CultureInfo.InvariantCulture;      
			
			colTag = new DataColumn("<b>Elements</b>",System.Type.GetType("System.String"));
			dtAtomFeeds.Columns.Add(colTag);
			
			colAttribute = new DataColumn("<b>Attributes</b>",System.Type.GetType("System.String"));
			dtAtomFeeds.Columns.Add(colAttribute);

			colValue = new DataColumn("<b>Value</b>",System.Type.GetType("System.String"));
			dtAtomFeeds.Columns.Add(colValue);

			insertDataRow("","Version","Atom 0.3");
			insertDataRow("","xmlns","http://purl.org/atom/ns#");
			
			if (feed03.AdditionalElements.Count > 0)
			{
				ScopedElement se = feed03.AdditionalElements[0];
				
				insertDataRow("","xmlns " + se.NamespacePrefix,XMLEncoding(se.NamespaceUri.AbsoluteUri));
			}
			else
			{
				foreach (AtomEntry03 entry in feed03.Entries)
				{
					if (entry.AdditionalElements.Count > 0)
					{
						ScopedElement se = entry.AdditionalElements[0];
						if(se.NamespaceUri.AbsoluteUri.Length !=0)
						{
							insertDataRow("","xmlns " + se.NamespacePrefix,XMLEncoding(se.NamespaceUri.AbsoluteUri));
						}
						break;
					}
				}
			}
			if (feed03.XmlLang != DefaultValues.Language)
			{
				insertDataRow("","Xml Language",Utility.ParseLanguage(feed03.XmlLang));
			}
			if (feed03.Title.Content.Length != 0)
			{
				insertDataRow("Title","",XMLEncoding(feed03.Title.Content));
			}                 
			if (feed03.Title.Mode != DefaultValues.Mode)
			{
				insertDataRow("","Mode",feed03.Title.Mode.ToString());
			}
			if (feed03.Title.Type != DefaultValues.MediaType)   
			{
				insertDataRow("","Type",Utility.ParseMediaType(feed03.Title.Type));
			}               
                          
			foreach (AtomLink link in feed03.Links)
			{
				insertDataRow("Link","","");
				insertDataRow("","Rel",Utility.ParseRelationship(link.Rel));
				insertDataRow("","Type",Utility.ParseMediaType(link.Type));
				
				if (link.HRef != DefaultValues.FeedUri)
				{
					insertDataRow("","Href",XMLEncoding(link.HRef.AbsoluteUri));						
				}
      			if(link.Title.Length != 0)
				{
					insertDataRow("","Title",XMLEncoding(link.Title));
				} 
			}              
             
			if (feed03.Author != null)
			{
				insertDataRow("Author","","");
				                 
				if (feed03.Author.Name.Length != 0)
				{
					insertDataRow("","Name",XMLEncoding(feed03.Author.Name));
				}
				if (feed03.Author.Url != DefaultValues.FeedUri)
				{
					insertDataRow("","Url",XMLEncoding((feed03.Author.Url.AbsoluteUri)));
				}
				if (feed03.Author.Email.Length != 0)
				{
					insertDataRow("","Email",XMLEncoding(feed03.Author.Email));
				}                                 
			}          

			if (feed03.Contributors != null)
			{
				foreach (AtomPersonConstruct contribute in feed03.Contributors)
				{
					insertDataRow("Contributor","","");
					if (contribute.Name.Length != 0)
					{
						insertDataRow("","Name",XMLEncoding(contribute.Name));
					}
					if (contribute.Url != DefaultValues.FeedUri)
					{
						insertDataRow("","Url",XMLEncoding(contribute.Url.AbsoluteUri));
					}
					if (contribute.Email.Length != 0)
					{
						insertDataRow("","Email",XMLEncoding(contribute.Email));
					}
				}
			}
			if (feed03.Id != DefaultValues.FeedUri)
			{
				insertDataRow("Id","",XMLEncoding(feed03.Id.AbsoluteUri));				
			}

			if (feed03.Copyright != null)
			{
				if (feed03.Copyright.Content.Length  != 0)
				{
					insertDataRow("Copyright","",XMLEncoding(feed03.Copyright.Content));
				}
				if (feed03.Copyright.Mode != DefaultValues.Mode)
				{
					insertDataRow("","Mode",feed03.Copyright.Mode.ToString());
				}
			}

			if (feed03.Info != null)
			{                   
				insertDataRow("Info","",XMLEncoding(feed03.Info.Content));                    
				
				if(feed03.Info.Mode != DefaultValues.Mode)
				{
					insertDataRow("","Mode",feed03.Info.Mode.ToString());
				}
				if(feed03.Info.Type != DefaultValues.MediaType)  
				{
					insertDataRow("","Type",Utility.ParseMediaType(feed03.Info.Type));
				}             
			}

			if (feed03.Modified != null) 
			{
				insertDataRow("Modified","",ParseDate(feed03.Modified)); 
			}

			if (feed03.Tagline != null)
			{
				if (feed03.Tagline.Content.Length != 0)
				{
					insertDataRow("TagLine","",XMLEncoding(feed03.Tagline.Content));
				}
				
				if (feed03.Tagline.Mode != DefaultValues.Mode)
				{
					insertDataRow("","Mode",feed03.Tagline.Mode.ToString());
				}
				if (feed03.Tagline.Type != DefaultValues.MediaType) 
				{
					insertDataRow("","Type",Utility.ParseMediaType(feed03.Tagline.Type));
				}                  
			}                
			return dtAtomFeeds;
		}
		#endregion

		#region Feeds10
		public DataTable DisplayFeed10(AtomFeed10 feed10)
		{
			dtAtomFeeds = new DataTable();
			dtAtomFeeds.Locale = System.Globalization.CultureInfo.InvariantCulture;   
			
			colTag = new DataColumn("<b>Elements</b>",System.Type.GetType("System.String"));
			dtAtomFeeds.Columns.Add(colTag);

			colAttribute = new DataColumn("<b>Attributes</b>",System.Type.GetType("System.String"));
			dtAtomFeeds.Columns.Add(colAttribute);

			colValue = new DataColumn("<b>Value</b>",System.Type.GetType("System.String"));
			dtAtomFeeds.Columns.Add(colValue);

			insertDataRow("","Version","Atom 1.0");
			insertDataRow("","xmlns","http://www.w3.org/2005/Atom");
           
			if (feed10.XmlLang != DefaultValues.Language)
			{
				insertDataRow("","Xml Language",Utility.ParseLanguage(feed10.XmlLang));
			}

			if (feed10.AdditionalElements.Count > 0)
			{
				ScopedElement se = feed10.AdditionalElements[0];
				insertDataRow("","xmlns " + se.NamespacePrefix,XMLEncoding(se.NamespaceUri.AbsoluteUri));
			}
			else
			{
				foreach (AtomEntry10 entry in feed10.Entries)
				{
					if (entry.AdditionalElements.Count > 0)
					{
						ScopedElement se = entry.AdditionalElements[0];
						if (se.NamespaceUri.AbsoluteUri.Length != 0)
						{
							insertDataRow("","xmlns:"+ se.NamespacePrefix,XMLEncoding(se.NamespaceUri.AbsoluteUri));
						}
						break;
					}
				}
			}
			if (feed10.Title.Content.Length != 0)
			{
				insertDataRow("Title","",XMLEncoding(feed10.Title.Content));
			}
			if (feed10.Title.Type  != DefaultValues.MediaType)
			{
				insertDataRow("","Type",Utility.ParseMediaType(feed10.Title.Type));
			}
			if (feed10.Title.Mode != DefaultValues.Mode)
			{
				insertDataRow("","Mode",feed10.Title.Mode.ToString());
			}
			if (feed10.Categories != null)   
			{
				foreach (AtomCategoryConstruct category in feed10.Categories)
				{
					insertDataRow("Category","","");
					insertDataRow("","Term", XMLEncoding(category.Term));
					
					insertDataRow("","Label",XMLEncoding(category.Label));					              
					insertDataRow("","Scheme",XMLEncoding(category.Scheme.AbsoluteUri));
				}
			}
			if (feed10.Links != null) 
			{
				foreach (AtomLink link in feed10.Links)
				{
					insertDataRow("Link","","");
					insertDataRow("","Rel",Utility.ParseRelationship(link.Rel));
					insertDataRow("","Type",Utility.ParseMediaType(link.Type));
                
					if (link.HRef != DefaultValues.FeedUri)
					{
						insertDataRow("","Href",XMLEncoding(link.HRef.AbsoluteUri));
					}

					if (link.HrefLang != DefaultValues.Language)
					{                       
						insertDataRow("","HrefLang",Utility.ParseLanguage(link.HrefLang));
					}
					if (link.Length != -1)
					{                       
						insertDataRow("","Length",link.Length.ToString());
					}
					if (link.Title.Length != 0)
					{
						insertDataRow("","Title",XMLEncoding(link.Title));
					}
				}
			}
			if (feed10.Authors != null)
			{
				foreach (AtomPersonConstruct author in feed10.Authors)
				{
					insertDataRow("Author","","");
					if (author.Name.Length != 0)
					{
						insertDataRow("","Name",XMLEncoding(author.Name));
					}
					if (author.Uri != DefaultValues.FeedUri) 
					{
						insertDataRow("","Uri",XMLEncoding(author.Uri.AbsoluteUri));
					}
					if (author.Email.Length >= 45)
					{                        
						insertDataRow("","Email",XMLEncoding(author.Email));
					}
					else if (author.Email.Length != 0)
					{
						insertDataRow("","Email",XMLEncoding(author.Email));
					}
				}
			}
			if (feed10.Contributors != null)
			{   
				foreach (AtomPersonConstruct contribute in feed10.Contributors)
				{                  
					insertDataRow("Contributor","","");
					
					if (contribute.Name.Length != 0)
					{
						insertDataRow("","Name",XMLEncoding(contribute.Name));
					}
					if (contribute.Uri  != DefaultValues.FeedUri)  
					{
						insertDataRow("","Uri",XMLEncoding(contribute.Uri.AbsoluteUri));
					}
					if(contribute.Email.Length  != 0)
					{
						insertDataRow("","Email",XMLEncoding(contribute.Email));
					}
				}
			}
			if (feed10.Id != DefaultValues.FeedUri)
			{               
				insertDataRow("Id","",XMLEncoding(feed10.Id.AbsoluteUri));
			}
			if (feed10.Icon != null)
			{
				if (feed10.Icon.Content.Length != 0)
				{
					insertDataRow("Icon","",XMLEncoding(feed10.Icon.Content));
				}
			}
			if (feed10.Logo != null)
			{
				if (feed10.Logo.Content.Length != 0)
				{ 
					insertDataRow("Logo","",XMLEncoding(feed10.Logo.Content));
				}
			}
			if (feed10.Rights != null)
			{
				if (feed10.Rights.Content.Length != 0)
				{
					insertDataRow("Rights","",XMLEncoding(feed10.Rights.Content));
				}
				
				if (feed10.Rights.Mode != DefaultValues.Mode)
				{
					insertDataRow("","Mode",feed10.Rights.Mode.ToString());
				}
				if (feed10.Rights.Type != DefaultValues.MediaType)
				{
					insertDataRow("","Type",Utility.ParseMediaType(feed10.Rights.Type));
				}       
			}
			if (feed10.Updated != null)  
			{
				insertDataRow("Updated","",ParseDate(feed10.Updated));
			}
			if(feed10.Subtitle != null) 
			{    
				if (feed10.Subtitle.Content.Length != 0)
				{
					insertDataRow("SubTitle","",XMLEncoding(feed10.Subtitle.Content));
				}
				if (feed10.Subtitle.Mode != DefaultValues.Mode)
				{
					insertDataRow("","Mode",feed10.Subtitle.Mode.ToString());
				}
				if (feed10.Subtitle.Type != DefaultValues.MediaType)
				{
					insertDataRow("","Type",Utility.ParseMediaType(feed10.Subtitle.Type));
				}
			}
			return dtAtomFeeds;
		}
		#endregion

		#region Entry03
		private DataTable DisplayEntry03(AtomFeed03 feed03)
		{
			dtAtomFeeds.Clear();
			foreach (AtomEntry03 entry in feed03.Entries)
			{
				if (entry.Title.Content.Length != 0)
				{
					insertDataRow("Title","",XMLEncoding(entry.Title.Content));
				}
				if(entry.Title.Mode != DefaultValues.Mode)
				{
					insertDataRow("","Mode", entry.Title.Mode.ToString());
				}
				if (entry.Title.Type != DefaultValues.MediaType)  
				{
				 	insertDataRow("","Type",Utility.ParseMediaType(entry.Title.Type));
				}
				if (entry.Links != null)
				{
					foreach (AtomLink link in entry.Links)
					{
						insertDataRow("Link","","");

						insertDataRow("","Rel",Utility.ParseRelationship(link.Rel));
						insertDataRow("","Type",Utility.ParseMediaType(link.Type));
                   
						if (link.HRef != DefaultValues.FeedUri)
						{
							insertDataRow("","Href",XMLEncoding(link.HRef.AbsoluteUri));
						}
						if (link.Title.Length  != 0)
						{
							insertDataRow("","Title",XMLEncoding(link.Title));
						}                         
					}                    
				}

				if (entry.Author != null)
				{
					insertDataRow("Author","","");

					if(entry.Author.Name.Length != 0)
					{
						insertDataRow("","Name",XMLEncoding(entry.Author.Name));
					}
					if (entry.Author.Uri != DefaultValues.FeedUri)
					{
						insertDataRow("","Url",XMLEncoding(entry.Author.Url.AbsoluteUri));
					}
					if (entry.Author.Email.Length != 0)
					{
						insertDataRow("","Email",XMLEncoding(entry.Author.Email));
					}
				}                
				if (entry.Contributors != null )
				{                    
					foreach (AtomPersonConstruct contribute in entry.Contributors)
					{
						insertDataRow("Contribute","","");
                     
						if (contribute.Name.Length != 0)
						{
							insertDataRow("","Name",XMLEncoding(contribute.Name));
						}
						if (contribute.Url != DefaultValues.FeedUri)
						{
							insertDataRow("","Url",XMLEncoding(contribute.Url.AbsoluteUri));
						}
						if (contribute.Email.Length != 0)
						{
							insertDataRow("","Email",XMLEncoding(contribute.Email));
						}
					}
				}
				if (entry.Id != DefaultValues.FeedUri)
				{
					if (entry.Id .AbsoluteUri.Length != 0)
					{
						insertDataRow("Id","",XMLEncoding(entry.Id.AbsoluteUri));
					}
				}
				if(entry.Modified != null)   
				{
					insertDataRow("Modified","",ParseDate(entry.Modified));
				}
				if(entry.Issued != null)  
				{
				 	insertDataRow("Issued","",ParseDate(entry.Issued));
				}
				if (entry.Created != null)  
				{
					insertDataRow("Created","",ParseDate(entry.Created));
				}
				if (entry.Summary != null)
				{ 
					if(entry.Summary.Content.Length  != 0)
					{
						insertDataRow("Summary","",XMLEncoding(entry.Summary.Content));
					}
					
					if (entry.Summary.Type != DefaultValues.MediaType)  
					{
					 	insertDataRow("","Type",Utility.ParseMediaType(entry.Summary.Type));
					}
					if (entry.Summary.Mode != DefaultValues.Mode)
					{
						insertDataRow("","Mode",entry.Summary.Mode.ToString());
					}
				}     
				if (entry.Contents != null)
				{                    
					foreach (AtomContent content in entry.Contents)
					{                 
						insertDataRow("Content","",XMLEncoding(content.Content));
												
						if (content.Type != DefaultValues.MediaType)  
						{
							insertDataRow("","Type",Utility.ParseMediaType(content.Type));
						}
						if (content.Mode != DefaultValues.Mode)
						{
							insertDataRow("","Mode",content.Mode.ToString());
						}
					}
				}
				if(entry.AdditionalElements != null)   
				{
					foreach (ScopedElement scoped in entry.AdditionalElements)
					{
						if (scoped.NamespacePrefix.Length != 0)
						{
							if (scoped.Content.Length != 0)
							{
								insertDataRow("",XMLEncoding(scoped.NamespacePrefix)+":"+scoped.LocalName,XMLEncoding(scoped.Content));
							}

						}             
					}
				}
				break;
			}
			return dtAtomFeeds;
		}
		#endregion

		#region Entry10

		private DataTable DisplayEntry10(AtomFeed10 feed10)
		{
			dtAtomFeeds.Clear();
			foreach (AtomEntry10 entry in feed10.Entries)
			{              
				if (entry.Title.Content.Length != 0)
				{
					insertDataRow("Title","",XMLEncoding(entry.Title.Content));
				}
				if (entry.Title.Mode != DefaultValues.Mode)
				{
					insertDataRow("","Mode",entry.Title.Mode.ToString());
				}
				if (entry.Title.Type != DefaultValues.MediaType)
				{
					insertDataRow("","Type",Utility.ParseMediaType(entry.Title.Type));
				}
				foreach (AtomLink link in entry.Links)
				{                   
					insertDataRow("Link","","");
					insertDataRow("","Rel",Utility.ParseRelationship(link.Rel));
					insertDataRow("","Type",Utility.ParseMediaType(link.Type));
					if (link.HRef != DefaultValues.FeedUri)
					{
						insertDataRow("","Href",XMLEncoding(link.HRef.AbsoluteUri));
					}   
					if (link.Title.Length != 0)
					{
						insertDataRow("","Title",XMLEncoding(link.Title));
					}
					if (link.Length != -1)
					{
						insertDataRow("","Length",link.Length.ToString());
					}
					if (link.HrefLang != DefaultValues.Language)
					{
						insertDataRow("","Launguage",Utility.ParseLanguage(link.HrefLang));
					}                   
				}

				if (entry.Categories != null)
				{                   
					foreach (AtomCategoryConstruct category in entry.Categories)
					{
						insertDataRow("Category","","");
						if(category.Term.Length != 0)
						{
							insertDataRow("","Term",category.Term);
						}
						if (category.Scheme != DefaultValues.FeedUri)  
						{
							insertDataRow("","Scheme",XMLEncoding(category.Scheme.AbsoluteUri));
						}
						if (category.Label.Length != 0)
						{
							insertDataRow("","Label",category.Label);
						}
					}
				}
              
				if(entry.Authors != null)
				{
					foreach (AtomPersonConstruct author in entry.Authors)
					{
						insertDataRow("Author","","");
                      
						if (author.Name.Length != 0)
						{
							insertDataRow("","Name",XMLEncoding(author.Name));
						}
						if (author.Uri != DefaultValues.FeedUri)
						{
							insertDataRow("","Uri",XMLEncoding(author.Uri.AbsoluteUri));
						}
						if (author.Email.Length != 0)
						{
							insertDataRow("","Email",XMLEncoding(author.Email));
						}
					}
				}         
             
				if (entry.Contributors != null)
				{  
					foreach (AtomPersonConstruct contribute in entry.Contributors)
					{
						insertDataRow("Contribute","","");
                
						if (contribute.Name.Length != 0)
						{
							insertDataRow("","Name",contribute.Name);
						}
						if (contribute.Uri != DefaultValues.FeedUri)
						{
							insertDataRow("","Url",XMLEncoding(contribute.Uri.AbsoluteUri));                           
						}
						if(contribute.Email.Length  != 0)
						{
							insertDataRow("","Email",XMLEncoding(contribute.Email));
						}
					}

					if (entry.Updated != null)
					{
						insertDataRow("Updated","",ParseDate(entry.Updated));
					}
					if (entry.Id != DefaultValues.FeedUri) 
					{                    
						if (entry.Id.AbsoluteUri.Length != 0)
						{ 
							insertDataRow("Id","",XMLEncoding(entry.Id.AbsoluteUri));
						}
					}
					if (entry.Published != null )  
					{
						insertDataRow("Published","",ParseDate(entry.Published));
					}
					if (entry.Summary!= null)
					{
						insertDataRow("Summary","",XMLEncoding(entry.Summary.Content));
						
						if(entry.Summary.Type != DefaultValues.MediaType)
						{
							insertDataRow("","Type",Utility.ParseMediaType(entry.Summary.Type));
						}
						if (entry.Summary.Mode != DefaultValues.Mode)
						{
							insertDataRow("","Mode",entry.Summary.Mode.ToString());
						}                   
					}
					if (entry.Content.Content.Length  != 0)
					{
						insertDataRow("Content","",XMLEncoding(entry.Content.Content));						
						
						if (entry.Content.Type != DefaultValues.MediaType)   
						{
							insertDataRow("","Type",Utility.ParseMediaType(entry.Content.Type));
						}
						if (entry.Content.Mode != DefaultValues.Mode)
						{
							insertDataRow("","Mode",entry.Content.Mode.ToString());
						}              
					}
					if (entry.Rights != null)
					{
						if(entry.Rights.Content.Length != 0)
						{
							insertDataRow("Rights","",XMLEncoding(entry.Rights.Content));
						}
					}
					if (entry.Source != null)
					{
						foreach(AtomSourceConstruct source in entry.Source)
						{                      
							insertDataRow("Source","","");
							if (source.Id != DefaultValues.FeedUri)
							{
								if(source.Id.AbsoluteUri.Length !=0)
								{
									insertDataRow("","Id",XMLEncoding(source.Id.AbsoluteUri));
								}
							}
							if (source.Rights.Length != 0)
							{
								insertDataRow("","Rights",source.Rights);
							}
							if(source.Title.Length != 0)
							{
								insertDataRow("","Title",XMLEncoding(source.Title));
							}

							if (source.Updated.DateTime.ToString() != null)
							{
								insertDataRow("","Updated",ParseDate(source.Updated));
							}                      
						}
					}             
					if (entry.AdditionalElements != null)   
					{
						foreach (ScopedElement scoped in entry.AdditionalElements)
						{
							if(scoped.NamespacePrefix.Length != 0)
							{
								if (scoped.Content.Length > 45)
								{
									insertDataRow(XMLEncoding(scoped.NamespacePrefix),"",scoped.LocalName);
									insertDataRow(XMLEncoding(scoped.Content),"","");
								}
								else if (scoped.Content.Length != 0)
								{
									insertDataRow(XMLEncoding(scoped.NamespacePrefix),"",scoped.LocalName);
									insertDataRow(XMLEncoding(scoped.Content),"","");
								}
							}            
						}
					}
				}
				break;
			}
			return dtAtomFeeds;
		}
		#endregion

		#region Grid Events
		private void dgAtomFeed_ItemCreated(object sender, DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				e.Item.Cells[0].Width = Unit.Percentage(15);
				e.Item.Cells[0].BackColor = System.Drawing.Color.Cornsilk;

				e.Item.Cells[1].Width = Unit.Percentage(15);
				e.Item.Cells[1].ForeColor = System.Drawing.Color.Blue;
				
				e.Item.Cells[2].Width = Unit.Percentage(70);
				e.Item.Cells[2].ForeColor = System.Drawing.Color.Red;
			}
		}

		private void dgEntry_ItemCreated(object sender, DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
			{
				e.Item.Cells[0].Width = Unit.Percentage(15);
				e.Item.Cells[0].BackColor = System.Drawing.Color.Cornsilk;

				e.Item.Cells[1].Width = Unit.Percentage(15);
				e.Item.Cells[1].ForeColor = System.Drawing.Color.Blue;
				
				e.Item.Cells[2].Width = Unit.Percentage(70);
				e.Item.Cells[2].ForeColor = System.Drawing.Color.Red;
				
			}	
		}

		#endregion

		#region Private Methods

		private void fillURLs()
		{
			 ddlURL.Items.Add(new ListItem(stringManager.GetString("strAtom03Url"), stringManager.GetString("strAtom03Url")));
			 ddlURL.Items.Add(new ListItem(stringManager.GetString("strAtom10Url"), stringManager.GetString("strAtom10Url")));		
		}
        private string XMLEncoding(string stitle)
        {
            StringBuilder strBuild = new StringBuilder(stitle);

            strBuild.Replace("&amp;", "")
                .Replace("&apos;", "'")
                .Replace("&quot;", "\"")
                .Replace("&lt;", "<")
                .Replace("&gt;", ">")
                .Replace("\n", "")
                .Replace("\r", "");

            return strBuild.ToString().Trim();

        }

		private string ParseDate(AtomDateConstruct dtDate)
		{
			System.IFormatProvider providerCulture = System.Globalization.CultureInfo.CurrentCulture;
                
			string utcOffset = "";
			string sign = "";
			if(dtDate.UtcOffset == DefaultValues.UtcOffset)
				utcOffset = "Z";
			else
			{
				utcOffset = dtDate.UtcOffset.ToString().Substring(0,
					dtDate.UtcOffset.ToString().Length - 3);
				sign = "+";

				// check if time zone is before GMT
				if(utcOffset[0].Equals('-'))
					sign = String.Empty;
			}

			string dateTime = dtDate.DateTime.ToString("s",providerCulture);

			string tempStr = String.Format(providerCulture,"{0}{1}{2}",
				dateTime,
				sign,
				utcOffset);
			return tempStr;

		}

		private void insertDataRow(string strTag,string strAttribute,string strValue)
		{
			dr = dtAtomFeeds.NewRow();
			dr[colTag] = strTag;
			dr[colAttribute] = strAttribute;
			dr[colValue] = strValue;
			dtAtomFeeds.Rows.Add(dr);
		}
		
		#endregion
		
	}
}
