/* 
  	* AtomStream.aspx.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.
*/
using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Net;
using System.IO;
using Web20Tools.Feed.Atom;
using System.Reflection;
using System.Resources;
using Web20Tools.Security;
using Web20Tools.ExceptionFramework;   

namespace Samples.Atom
{
	/// <summary>
	/// Write an ATOM Feed to an HTTP Response Stream.
	/// </summary>
	public class AtomStream : System.Web.UI.Page
	{
        protected System.Web.UI.HtmlControls.HtmlForm Form1;
        protected System.Web.UI.WebControls.RadioButton rdSelectUrl;
        protected System.Web.UI.WebControls.DropDownList ddlURL;
        protected System.Web.UI.WebControls.RadioButton rdEnterUrl;
        protected System.Web.UI.WebControls.TextBox txtURL;
        protected System.Web.UI.WebControls.Button btnCreate;
        protected System.Web.UI.WebControls.Label lblMsg;
        protected System.Web.UI.WebControls.HyperLink hlOpenXML;

		protected System.Web.UI.WebControls.Label lblFeed;
		protected System.Web.UI.WebControls.DataGrid dgAtomFeed;
		protected System.Web.UI.WebControls.Label lblEntry;
		protected System.Web.UI.WebControls.DataGrid dgEntry;
        protected System.Web.UI.WebControls.HyperLink hlViewError;
        protected System.Web.UI.WebControls.Label lblError;
		private ResourceManager stringManager = new ResourceManager("Samples.SamplesResource",Assembly.GetExecutingAssembly()); 
	
		protected void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			
			if(!IsPostBack)
			{
				fillURLs();
				txtURL.Enabled=false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked=true;
				rdSelectUrl.Attributes.Add("OnClick","return EnableDiableURLControls();");
				rdEnterUrl.Attributes.Add("OnClick","return EnableDiableURLControls();");
                hlViewError.Attributes.Add("OnClick", "return ShowError();");
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
		}
		#endregion

		protected void btnCreate_Click(object sender, System.EventArgs e)
		{
			try
			{
                License.LoadLicense(); 
				AtomFeed feed;
				lblMsg.Text = stringManager.GetString("strBlank");
				
				if(rdSelectUrl.Checked)
				{
					feed = AtomFeed.Load(ddlURL.SelectedValue);
					ddlURL.Enabled = true;
					txtURL.Enabled = false;
#if(VS8)
                    ClientScript.RegisterClientScriptBlock(Type.GetType("System.String"), "", "<script language='javascript'>window.open('AtomShowStream.aspx?url=" + ddlURL.SelectedValue + "');</script>");   
#else
					Page.RegisterClientScriptBlock("","<script language='javascript'>window.open('AtomShowStream.aspx?url=" + ddlURL.SelectedValue + "');</script>"); 
#endif
				}	
				else
				{
                    if (!txtURL.Text.ToUpper().StartsWith("http://".ToUpper()))
                        txtURL.Text = "http://" + txtURL.Text;
					feed = AtomFeed.Load(txtURL.Text);
					txtURL.Enabled = true;
					ddlURL.Enabled = false;
#if(VS8)
                    ClientScript.RegisterClientScriptBlock(Type.GetType("System.String"), "", "<script language='javascript'>window.open('AtomShowStream.aspx?url=" + txtURL.Text + "');</script>");   
#else
					Page.RegisterClientScriptBlock("","<script language='javascript'>window.open('AtomShowStream.aspx?url=" + txtURL.Text+ "');</script>"); 
#endif
				}
                hlViewError.Text = stringManager.GetString("strBlank");
                hlViewError.NavigateUrl = stringManager.GetString("strBlank");
                lblError.Text = stringManager.GetString("strBlank");
			}
			catch(AtomReaderException ex)
			{
				hlOpenXML.Text = stringManager.GetString("strBlank");;
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdEnterUrl.Checked = false;
				if(ex.Message == stringManager.GetString("strUnlicensed"))
					lblMsg.Text = stringManager.GetString("strLicenseException");
				else
                    lblMsg.Text = stringManager.GetString("strErrorReading");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
            catch (InvalidLicenseException ilex)
            {
                hlOpenXML.Text = stringManager.GetString("strBlank"); ;
                txtURL.Enabled = false;
                txtURL.Text = stringManager.GetString("strHttp");
                rdSelectUrl.Checked = true;
                rdEnterUrl.Checked = false;
                lblMsg.Text = stringManager.GetString("strLicenseException");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ilex.Message;
            }
            catch (InvalidLicenseInfoException iliex)
            {
                hlOpenXML.Text = stringManager.GetString("strBlank"); ;
                txtURL.Enabled = false;
                txtURL.Text = stringManager.GetString("strHttp");
                rdSelectUrl.Checked = true;
                rdEnterUrl.Checked = false;
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = iliex.Message;
            }
			catch(Exception ex)
			{
				hlOpenXML.Text = stringManager.GetString("strBlank");;
				txtURL.Enabled = false;
				txtURL.Text = stringManager.GetString("strHttp");
				rdSelectUrl.Checked = true;
				rdEnterUrl.Checked = false;
				lblMsg.Text = stringManager.GetString("strErrorReading");

                hlViewError.Text = stringManager.GetString("strViewError");
                hlViewError.NavigateUrl = "#";
                lblError.Text = ex.Message;
			}
		}

		private void fillURLs()
		{
			ddlURL.Items.Add(new ListItem(stringManager.GetString("strAtom03Url"), stringManager.GetString("strAtom03Url")));
			ddlURL.Items.Add(new ListItem(stringManager.GetString("strAtom10Url"), stringManager.GetString("strAtom10Url")));
		}

	}
}
