' AtomCombine.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.

Imports System
Imports System.Collections 
Imports System.ComponentModel 
Imports System.Data 
Imports System.Drawing 
Imports System.Web 
Imports System.Web.SessionState 
Imports System.Web.UI 
Imports System.Web.UI.WebControls 
Imports System.Web.UI.HtmlControls 
Imports Web20Tools.Feed.Atom
Imports System.Resources
Imports System.Reflection
Imports Web20Tools.Feed
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework

Namespace Samples.Atom
    ''' <summary>
    ''' Read multiple ATOM feeds and aggregate into a single feed (filtered)
    ''' </summary>
    Public Class AtomCombine
        Inherits System.Web.UI.Page

        Protected WithEvents Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected WithEvents lblCreated As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXMLTop As System.Web.UI.WebControls.HyperLink
        Protected WithEvents rdddl As System.Web.UI.WebControls.RadioButton
        Protected WithEvents ddlUrls As System.Web.UI.WebControls.DropDownList
        Protected WithEvents rdtxt As System.Web.UI.WebControls.RadioButton
        Protected WithEvents txtEnterUrl As System.Web.UI.WebControls.TextBox
        Protected WithEvents btnAddUrls As System.Web.UI.WebControls.Button
        Protected WithEvents btnRemove As System.Web.UI.WebControls.Button
        Protected WithEvents lbURL As System.Web.UI.WebControls.ListBox
        Protected WithEvents txtchTitle As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtchLink As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtchFeedId As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtchAuthor As System.Web.UI.WebControls.TextBox
        Protected WithEvents ddlitem As System.Web.UI.WebControls.DropDownList
        Protected WithEvents ddloption As System.Web.UI.WebControls.DropDownList
        Protected WithEvents txtKeyword As System.Web.UI.WebControls.TextBox
        Protected WithEvents btnAggregate As System.Web.UI.WebControls.Button
        Protected WithEvents lblMsg As System.Web.UI.WebControls.Label
        Protected WithEvents lblCreatedBottom As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXML As System.Web.UI.WebControls.HyperLink
        Protected btnNext As System.Web.UI.WebControls.Button
        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label

        Private stringManager As New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly())

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            If Not IsPostBack Then
                FillUrls()
                txtEnterUrl.Enabled = False
                rdddl.Checked = True
                rdddl.Attributes.Add("OnClick", "return EnableDisable();")
                rdtxt.Attributes.Add("OnClick", "return EnableDisable();")
                btnAddUrls.Attributes.Add("OnClick", "return AddUrls();")
                btnAggregate.Attributes.Add("OnClick", "return Aggregate();")
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub

        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()

        End Sub

        Private Sub FillUrls()
            ddlUrls.Items.Clear()
            ddlUrls.Items.Add(New ListItem(stringManager.GetString("strAtom03Url"), stringManager.GetString("strAtom03Url")))
            ddlUrls.Items.Add(New ListItem(stringManager.GetString("strAtom10Url"), stringManager.GetString("strAtom10Url")))
            ddlitem.Items.Clear()
            ddlitem.Items.Add(New ListItem("Title", "Title"))
            ddlitem.Items.Add(New ListItem("Content", "Content"))
            ddloption.Items.Clear()
            ddloption.Items.Add(New ListItem("StartsWith", "StartsWith"))
            ddloption.Items.Add(New ListItem("EndsWith", "EndsWith"))
            ddloption.Items.Add(New ListItem("Contains", "Contains"))
            ddloption.Items.Add(New ListItem("Equals", "Equals"))
            ddloption.Items.Add(New ListItem("Not Equals", "NotEquals"))
        End Sub

        Private Sub btnAggregate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAggregate.Click
            LoadFeeds()
        End Sub

        Private Sub LoadFeeds()
            Try
                License.LoadLicense()
                Dim feed As AtomFeed10 = New AtomFeed10
                Dim i As Integer = 0
                While i < lbURL.Items.Count
                    Dim tempfeed As AtomFeed = AtomFeed.Load(lbURL.Items(i).Value)
                    Dim feed10 As AtomFeed10
                    If tempfeed.Version = AtomVersion.Atom03 Then
                        Dim feed03 As AtomFeed03 = CType(tempfeed, AtomFeed03)
                        feed10 = feed03.Convert(AtomVersion.Atom10)
                    Else
                        feed10 = CType(tempfeed, AtomFeed10)
                    End If
                    For Each entry10 As AtomEntry10 In feed10.Entries
                        If ApplyConstraint(entry10) Then
                            If entry10.Id Is DefaultValues.FeedUri Then
                                entry10.Id = New FeedUri(txtchFeedId.Text)
                            End If

                            feed.Entries.Add(entry10)
                        End If
                    Next
                    System.Math.Min(System.Threading.Interlocked.Increment(i), i - 1)
                End While
                Dim feedLink As AtomLink = New AtomLink
                If Not txtchLink.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtchLink.Text = "http://" + txtchLink.Text
                End If
                feedLink.HRef = New FeedUri(txtchLink.Text)
                feed.Links.Add(feedLink)
                If Not txtchFeedId.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtchFeedId.Text = "http://" + txtchFeedId.Text
                End If
                feed.Id = New FeedUri(txtchFeedId.Text)
                Dim objFeedTitle As AtomContentConstruct = New AtomContentConstruct("Title", txtchTitle.Text)
                feed.Title = objFeedTitle
                Dim objAuthor As AtomPersonConstruct = New AtomPersonConstruct
                objAuthor.Name = txtchAuthor.Text
                Dim objFeedUpdated As AtomDateConstruct = New AtomDateConstruct
                objFeedUpdated.DateTime = Convert.ToDateTime(DateTime.Now)
                feed.Updated = objFeedUpdated
                feed.Authors.Add(objAuthor)
                If Not (feed.Entries.Count = 0) Then
                    Session.Add("AtomFeed", feed)
                    lblCreated.Text = stringManager.GetString("strCreated")
                    lblCreatedBottom.Text = stringManager.GetString("strCreated")
                    hlOpenXML.Text = stringManager.GetString("strClick")
                    hlOpenXMLTop.Text = stringManager.GetString("strClick")
                    hlOpenXML.NavigateUrl = "AtomShowFeed.aspx"
                    hlOpenXMLTop.NavigateUrl = "AtomShowFeed.aspx"
                    hlOpenXML.Target = "_blank"
                    hlOpenXMLTop.Target = "_blank"
                    lblMsg.Text = stringManager.GetString("strBlank")
                Else
                    lblCreated.Text = stringManager.GetString("strBlank")
                    lblCreatedBottom.Text = stringManager.GetString("strBlank")
                    hlOpenXML.Text = stringManager.GetString("strBlank")
                    hlOpenXMLTop.Text = stringManager.GetString("strBlank")
                    lblMsg.Text = stringManager.GetString("strNoMatch")
                End If

                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
            Catch ex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLTop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            Catch liex As InvalidLicenseInfoException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLTop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLTop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strErrorCreating")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub

        Private Sub btnAddUrls_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddUrls.Click
            If rdddl.Checked = True Then
                lbURL.Items.Add(ddlUrls.SelectedValue)
                txtEnterUrl.Enabled = False
                ddlUrls.Enabled = True

            Else
                If rdtxt.Checked = True Then
                    If Not txtEnterUrl.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                        txtEnterUrl.Text = "http://" + txtEnterUrl.Text
                    End If
                    lbURL.Items.Add(txtEnterUrl.Text)
                    ddlUrls.Enabled = False
                    txtEnterUrl.Enabled = True
                    txtEnterUrl.Text = stringManager.GetString("strHttp")
                End If
                End If
                lblMsg.Text = stringManager.GetString("strBlank")
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
            hlOpenXMLTop.Text = stringManager.GetString("strBlank")
            hlViewError.Text = stringManager.GetString("strBlank")
        End Sub

        Private Function FilterItem() As String
            Dim filterentry As String = String.Empty
            Select Case ddlitem.SelectedValue.ToLower
                Case "title"
                    filterentry = "title"
                Case "content"
                    filterentry = "content"
                Case "link"
                    filterentry = "link"
            End Select
            Return filterentry
        End Function

        Private Function FilterOperation() As String
            Dim filtertype As String = String.Empty
            Select Case ddloption.SelectedValue.ToLower
                Case "startswith"
                    filtertype = "startswith"
                Case "endswith"
                    filtertype = "endswith"
                Case "contains"
                    filtertype = "contains"
                Case "equals"
                    filtertype = "equals"
                Case "notequals"
                    filtertype = "notequals"
            End Select
            Return filtertype
        End Function

        Private Function ApplyConstraint(ByVal entry As AtomEntry10) As Boolean
            If txtKeyword.Text.Length = 0 Then
                Return True
            Else
                Dim item As String
                Dim operation As String
                item = FilterItem()
                operation = FilterOperation()
                If item = "title" Then
                    If operation = "startswith" Then
                        If entry.Title.Content.Trim.ToLower.StartsWith(txtKeyword.Text.Trim.ToLower) Then
                            Return True
                        Else
                            Return False
                        End If
                    End If
                    If operation = "endswith" Then
                        If entry.Title.Content.Trim.ToLower.EndsWith(txtKeyword.Text.Trim.ToLower) Then
                            Return True
                        Else
                            Return False
                        End If
                    End If
                    If operation = "contains" Then
                        If entry.Title.Content.Trim.ToLower.IndexOf(txtKeyword.Text.Trim.ToLower) = -1 Then
                            Return False
                        Else
                            Return True
                        End If
                    End If
                    If operation = "equals" Then
                        If (String.Compare(entry.Title.Content.Trim, txtKeyword.Text.Trim, True, System.Globalization.CultureInfo.CurrentCulture) = 0) Then
                            Return True
                        Else
                            Return False
                        End If
                    End If
                    If operation = "notequals" Then
                        If Not (String.Compare(entry.Title.Content.Trim, txtKeyword.Text.Trim, True, System.Globalization.CultureInfo.CurrentCulture) = 0) Then
                            Return True
                        Else
                            Return False
                        End If
                    End If
                End If
                If item = "content" Then
                    If operation = "startswith" Then
                        If entry.Summary.Content.Trim.ToLower.StartsWith(txtKeyword.Text.Trim.ToLower) Then
                            Return True
                        Else
                            Return False
                        End If
                    End If
                    If operation = "endswith" Then
                        If entry.Summary.Content.Trim.ToLower.EndsWith(txtKeyword.Text.Trim.ToLower) Then
                            Return True
                        Else
                            Return False
                        End If
                    End If
                    If operation = "contains" Then
                        If entry.Summary.Content.Trim.ToLower.IndexOf(txtKeyword.Text.Trim.ToLower) = -1 Then
                            Return False
                        Else
                            Return True
                        End If
                    End If
                    If operation = "equals" Then
                        If (String.Compare(entry.Summary.Content.Trim, txtKeyword.Text.Trim, True, System.Globalization.CultureInfo.CurrentCulture) = 0) Then
                            Return True
                        Else
                            Return False
                        End If
                    End If
                    If operation = "notequals" Then
                        If Not (String.Compare(entry.Summary.Content.Trim, txtKeyword.Text.Trim, True, System.Globalization.CultureInfo.CurrentCulture) = 0) Then
                            Return True
                        Else
                            Return False
                        End If
                    End If
                End If
            End If
            Return False
        End Function

        Private Sub btnRemove_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnRemove.Click
            If lbURL.SelectedIndex > -1 Then
                lbURL.Items.Remove(lbURL.SelectedItem)
            End If
            lblMsg.Text = stringManager.GetString("strBlank")
            lblCreated.Text = stringManager.GetString("strBlank")
            lblCreatedBottom.Text = stringManager.GetString("strBlank")
            hlOpenXML.Text = stringManager.GetString("strBlank")
            hlOpenXMLTop.Text = stringManager.GetString("strBlank")
            hlViewError.Text = stringManager.GetString("strBlank")
        End Sub
    End Class
End Namespace
