' AtomConvert.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.

Imports System
Imports System.Collections 
Imports System.ComponentModel 
Imports System.Data 
Imports System.Drawing 
Imports System.Web 
Imports System.Web.SessionState 
Imports System.Web.UI 
Imports System.Web.UI.WebControls 
Imports System.Web.UI.HtmlControls 
Imports Web20Tools.Feed.Atom
Imports System.Resources
Imports System.Reflection
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework

Namespace Samples.Atom
    ''' <summary>
    ''' Convert an ATOM feed
    ''' </summary>
    Public Class AtomConvert
        Inherits System.Web.UI.Page
        Protected WithEvents Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected WithEvents lblCreated As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXMLtop As System.Web.UI.WebControls.HyperLink
        Protected WithEvents rdSelectUrl As System.Web.UI.WebControls.RadioButton
        Protected WithEvents ddlURL As System.Web.UI.WebControls.DropDownList
        Protected WithEvents rdEnterUrl As System.Web.UI.WebControls.RadioButton
        Protected WithEvents txtURL As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblConvertVer As System.Web.UI.WebControls.Label
        Protected WithEvents ddlConvertVer As System.Web.UI.WebControls.DropDownList
        Protected WithEvents btnLoad As System.Web.UI.WebControls.Button
        Protected WithEvents lblMsg As System.Web.UI.WebControls.Label
        Protected WithEvents lblCreatedBottom As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXML As System.Web.UI.WebControls.HyperLink

        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label

        Private stringManager As New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly())

        Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)

            If Not IsPostBack Then
                fillURLs()
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdSelectUrl.Attributes.Add("OnClick", "return EnableDisableURLControls();")
                rdEnterUrl.Attributes.Add("OnClick", "return EnableDisableURLControls();")
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub

        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()
            AddHandler Me.btnLoad.Click, AddressOf Me.btnLoad_Click
            AddHandler Me.Load, AddressOf Me.Page_Load
        End Sub

        Private Sub btnLoad_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            Try
                License.LoadLicense()
                LoadAttribute()
                Convert()

                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
            Catch ex As AtomReaderException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                If (ex.Message = stringManager.GetString("strUnlicensed")) Then
                    lblMsg.Text = stringManager.GetString("strLicenseException")
                Else
                    lblMsg.Text = ex.Message
                End If
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message

            Catch lex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = lex.Message
            Catch liex As InvalidLicenseInfoException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strConvertError")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub

        Private Sub LoadAttribute()
            btnLoad.Attributes.Add("OnClick", "return checkURL();")
        End Sub

        Private Sub fillURLs()
            ddlURL.Items.Add(New ListItem(stringManager.GetString("strAtom03Url"), stringManager.GetString("strAtom03Url")))
            ddlURL.Items.Add(New ListItem(stringManager.GetString("strAtom10Url"), stringManager.GetString("strAtom10Url")))
        End Sub

        Private Sub Convert()
            Dim url As String = String.Empty
            Dim convert As Boolean = False
            If rdSelectUrl.Checked = True Then
                url = ddlURL.SelectedValue
            End If
            If rdEnterUrl.Checked = True Then
                If Not txtURL.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtURL.Text = "http://" + txtURL.Text
                End If
                url = txtURL.Text
            End If
            Dim feed As AtomFeed
            feed = AtomFeed.Load(url)
            If ddlConvertVer.SelectedValue = "0.3" Then
                If Not (feed.Version = AtomVersion.Atom03) Then
                    Dim feed10 As AtomFeed10 = AtomFeed10.Load(url)
                    Dim feed03 As AtomFeed03 = feed10.Convert(AtomVersion.Atom03)
                    convert = True
                    lblMsg.Text = stringManager.GetString("strBlank")
                    Session.Add("AtomFeed", feed03)
                Else
                    lblMsg.Text = String.Format(stringManager.GetString("strFeedMsg"), "0.3")
                    lblCreated.Text = stringManager.GetString("strBlank")
                    lblCreatedBottom.Text = stringManager.GetString("strBlank")
                    hlOpenXML.Text = stringManager.GetString("strBlank")
                    hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                    Session("AtomFeed") = Nothing
                End If
            End If
            If ddlConvertVer.SelectedValue = "1.0" Then
                If Not (feed.Version = AtomVersion.Atom10) Then
                    Dim feed03 As AtomFeed03 = AtomFeed03.Load(url)
                    Dim feed10 As AtomFeed10 = feed03.Convert(AtomVersion.Atom10)
                    convert = True
                    lblMsg.Text = stringManager.GetString("strBlank")
                    Session.Add("AtomFeed", feed10)
                Else
                    lblMsg.Text = String.Format(stringManager.GetString("strFeedMsg"), "1.0")
                    lblCreated.Text = stringManager.GetString("strBlank")
                    lblCreatedBottom.Text = stringManager.GetString("strBlank")
                    hlOpenXML.Text = stringManager.GetString("strBlank")
                    hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                    Session("AtomFeed") = Nothing
                End If
            End If
            If convert = True Then
                lblCreated.Text = stringManager.GetString("strCreated")
                lblCreatedBottom.Text = stringManager.GetString("strCreated")
                hlOpenXML.Text = stringManager.GetString("strClick")
                hlOpenXMLtop.Text = stringManager.GetString("strClick")
                hlOpenXML.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXML.Target = "_blank"
                hlOpenXMLtop.Target = "_blank"
                lblMsg.Text = stringManager.GetString("strBlank")
            End If
        End Sub
    End Class
End Namespace
