' AtomCreate.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.

Imports System
Imports System.Collections 
Imports System.ComponentModel 
Imports System.Data 
Imports System.Drawing 
Imports System.Web 
Imports System.Web.SessionState 
Imports System.Web.UI 
Imports System.Web.UI.WebControls 
Imports System.Web.UI.HtmlControls 
Imports System.Xml 
Imports Web20Tools.Feed.Atom 
Imports System.IO
Imports System.Resources
Imports System.Reflection
Imports Web20Tools.Feed
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework

Namespace Samples.Atom
    ''' <summary>
    ''' Create an ATOM feed
    ''' </summary>
    Public Class AtomCreate
        Inherits System.Web.UI.Page
        Protected WithEvents Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected WithEvents lblCreated As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXMLtop As System.Web.UI.WebControls.HyperLink
        Protected WithEvents ddlVersions As System.Web.UI.WebControls.DropDownList
        Protected WithEvents txtFeedTitle As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtFeedLinkHref As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblFeedModify As System.Web.UI.WebControls.Label
        Protected WithEvents txtFeedModified As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtFeedAuthorName As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtFeedId As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtEntryTitle As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtEntryLinkHref As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblEntryId As System.Web.UI.WebControls.Label
        Protected WithEvents lblColon As System.Web.UI.WebControls.Label
        Protected WithEvents txtEntryId As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblEntryModify As System.Web.UI.WebControls.Label
        Protected WithEvents txtEntryModified As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblEntryIssue As System.Web.UI.WebControls.Label
        Protected WithEvents txtEntryIssued As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtEntrySummary As System.Web.UI.WebControls.TextBox
        Protected WithEvents btnSave As System.Web.UI.WebControls.Button
        Protected WithEvents lblMsg As System.Web.UI.WebControls.Label
        Protected WithEvents lblCreatedBottom As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXML As System.Web.UI.WebControls.HyperLink

        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label

        Protected btnModified03 As System.Web.UI.WebControls.Button
        Private stringManager As New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly())

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            If Not IsPostBack Then
                ddlVersions.Attributes.Add("OnChange", "return clearLables();")
                ddlVersions.Attributes.Add("OnChange", "return showVersionDiv();")
                loadDefaultValues()
                fillVersions()
                btnSave.Attributes.Add("OnClick", "return clearLables();")
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
#If VS8 Then
                ClientScript.RegisterStartupScript(Type.GetType("System.String"), "Start", "<script language=JavaScript>showVersionDiv();</script>")
#Else
                RegisterStartupScript("Start", "<script language=JavaScript>showVersionDiv();</script>")
#End If
            End If
        End Sub

        Private Sub loadDefaultValues()
            txtFeedTitle.Text = stringManager.GetString("strFeedTitle")
            txtFeedLinkHref.Text = stringManager.GetString("strFeedLink")
            txtFeedModified.Text = "08/01/2006"
            txtFeedId.Text = stringManager.GetString("strFeedLink")
            txtFeedAuthorName.Text = stringManager.GetString("strAuthor")
            txtEntryTitle.Text = stringManager.GetString("strEntryTitle")
            txtEntryLinkHref.Text = "http://www.web20tools.net/Products/Atom_Library/Features.aspx"
            txtEntryModified.Text = "08/01/2006"
            txtEntryIssued.Text = "08/01/2006"
            txtEntryId.Text = stringManager.GetString("strFeedLink")
            txtEntrySummary.Text = stringManager.GetString("strContent")
        End Sub

        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()

        End Sub

        Private Sub fillVersions()
            ddlVersions.Items.Add("Atom 0.3")
            ddlVersions.Items.Add("Atom 1.0")
        End Sub

        Private Sub btnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSave.Click
            If ddlVersions.SelectedItem.Text = "Atom 0.3" Then
                saveAtom03()
            Else
                saveAtom10()
            End If
#If VS8 Then
            ClientScript.RegisterStartupScript(Type.GetType("System.String"), "Start", "<script language=JavaScript>showVersion();</script>")
#Else
            RegisterStartupScript("Start", "<script language=JavaScript>showVersion();</script>")
#End If
        End Sub

        Private Sub saveAtom03()
            Try
                License.LoadLicense()
                Dim objAtomFeed03 As AtomFeed03 = New AtomFeed03
                Dim objAtomEntry03 As AtomEntry03 = New AtomEntry03
                Dim objFeedTitle As AtomContentConstruct = New AtomContentConstruct("title", txtFeedTitle.Text)
                objAtomFeed03.Title = objFeedTitle
                Dim feedLink As AtomLink = New AtomLink
                If Not txtFeedLinkHref.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtFeedLinkHref.Text = "http://" + txtFeedLinkHref.Text
                End If
                feedLink.HRef = New FeedUri(txtFeedLinkHref.Text)
                objAtomFeed03.Links.Add(feedLink)
                If Not txtFeedId.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtFeedId.Text = "http://" + txtFeedId.Text
                End If
                objAtomFeed03.Id = New FeedUri(txtFeedId.Text)
                Dim objFeedModified As AtomDateConstruct = New AtomDateConstruct
                Dim tempDate As DateTime = Convert.ToDateTime(txtFeedModified.Text, System.Globalization.CultureInfo.CurrentCulture)
                objFeedModified.DateTime = tempDate
                objAtomFeed03.Modified = objFeedModified
                Dim objAuthor As AtomPersonConstruct = New AtomPersonConstruct
                objAuthor.Name = txtFeedAuthorName.Text
                objAtomFeed03.Author = objAuthor
                Dim objEntryTitle As AtomContentConstruct = New AtomContentConstruct("title", txtEntryTitle.Text)
                objAtomEntry03.Title = objEntryTitle
                Dim entryLink As AtomLink = New AtomLink
                If Not txtEntryLinkHref.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtEntryLinkHref.Text = "http://" + txtEntryLinkHref.Text
                End If
                entryLink.HRef = New FeedUri(txtEntryLinkHref.Text)
                objAtomEntry03.Links.Add(entryLink)
                Dim objEntryModified As AtomDateConstruct = New AtomDateConstruct
                objEntryModified.DateTime = Convert.ToDateTime(txtEntryModified.Text, System.Globalization.CultureInfo.CurrentCulture)
                objAtomEntry03.Modified = objEntryModified
                Dim objEntryIssued As AtomDateConstruct = New AtomDateConstruct("issued", Convert.ToDateTime(txtEntryIssued.Text, System.Globalization.CultureInfo.CurrentCulture))
                objAtomEntry03.Issued = objEntryIssued
                objAtomFeed03.Entries.Add(objAtomEntry03)
                Session.Add("AtomFeed", objAtomFeed03)

                lblCreated.Text = stringManager.GetString("strCreated")
                lblCreatedBottom.Text = stringManager.GetString("strCreated")
                hlOpenXML.Text = stringManager.GetString("strClick")
                hlOpenXMLtop.Text = stringManager.GetString("strClick")
                hlOpenXML.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXML.Target = "_blank"
                hlOpenXMLtop.Target = "_blank"
                lblMsg.Text = stringManager.GetString("strBlank")

                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
            Catch ex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            Catch liex As InvalidLicenseInfoException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strErrorCreating")
                Session("AtomFeed") = Nothing

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub

        Private Sub saveAtom10()
            Try
                License.LoadLicense()
                Dim objAtomFeed10 As AtomFeed10 = New AtomFeed10
                Dim objAtomEntry10 As AtomEntry10 = New AtomEntry10
                Dim objFeedTitle As AtomContentConstruct = New AtomContentConstruct("title", txtFeedTitle.Text)
                objAtomFeed10.Title = objFeedTitle
                Dim feedLink As AtomLink = New AtomLink
                If Not txtFeedLinkHref.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtFeedLinkHref.Text = "http://" + txtFeedLinkHref.Text
                End If
                feedLink.HRef = New FeedUri(txtFeedLinkHref.Text)
                objAtomFeed10.Links.Add(feedLink)
                If Not txtFeedId.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtFeedId.Text = "http://" + txtFeedId.Text
                End If
                objAtomFeed10.Id = New FeedUri(txtFeedId.Text)
                Dim objFeedUpdated As AtomDateConstruct = New AtomDateConstruct("updated", Convert.ToDateTime(txtFeedModified.Text, System.Globalization.CultureInfo.CurrentCulture))
                objAtomFeed10.Updated = objFeedUpdated
                Dim objAuthor As AtomPersonConstruct = New AtomPersonConstruct
                objAuthor.Name = txtFeedAuthorName.Text
                objAtomFeed10.Authors.Add(objAuthor)
                Dim objEntryTitle As AtomContentConstruct = New AtomContentConstruct("title", txtEntryTitle.Text)
                objAtomEntry10.Title = objEntryTitle
                Dim entryLink As AtomLink = New AtomLink
                If Not txtEntryLinkHref.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtEntryLinkHref.Text = "http://" + txtEntryLinkHref.Text
                End If
                entryLink.HRef = New FeedUri(txtEntryLinkHref.Text)
                objAtomEntry10.Links.Add(entryLink)
                Dim objEntryUpdated As AtomDateConstruct = New AtomDateConstruct("updated", Convert.ToDateTime(txtEntryModified.Text, System.Globalization.CultureInfo.CurrentCulture))
                objAtomEntry10.Updated = objEntryUpdated
                If Not txtEntryId.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                    txtEntryId.Text = "http://" + txtEntryId.Text
                End If
                objAtomEntry10.Id = New FeedUri(txtEntryId.Text)
                Dim objEntrySummary As AtomContentConstruct = New AtomContentConstruct("summary", txtEntrySummary.Text)
                objAtomEntry10.Summary = objEntrySummary
                objAtomFeed10.Entries.Add(objAtomEntry10)
                Session.Add("AtomFeed", objAtomFeed10)

                lblCreated.Text = stringManager.GetString("strCreated")
                lblCreatedBottom.Text = stringManager.GetString("strCreated")
                hlOpenXML.Text = stringManager.GetString("strClick")
                hlOpenXMLtop.Text = stringManager.GetString("strClick")
                hlOpenXML.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXML.Target = "_blank"
                hlOpenXMLtop.Target = "_blank"
                lblMsg.Text = stringManager.GetString("strBlank")

                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
            Catch ex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            Catch liex As InvalidLicenseInfoException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strErrorCreating")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub
    End Class
End Namespace
