' AtomEmbeddedPassword.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.

Imports System
Imports System.Collections 
Imports System.ComponentModel 
Imports System.Data 
Imports System.Drawing 
Imports System.Web 
Imports System.Web.SessionState 
Imports System.Web.UI 
Imports System.Web.UI.WebControls 
Imports System.Web.UI.HtmlControls 
Imports Web20Tools.Feed.Atom
Imports System.Resources
Imports System.Reflection
Imports Web20Tools.Security
Imports System.Text
Imports Web20Tools.ExceptionFramework

Namespace Samples.Atom
    ''' <summary>
    ''' Read Password Protected ATOM feeds: (Passing credentials in URL)
    ''' </summary>
    Public Class AtomEmbeddedPassword
        Inherits System.Web.UI.Page
        Protected WithEvents Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected WithEvents rdSelectUrl As System.Web.UI.WebControls.RadioButton
        Protected WithEvents ddlURL As System.Web.UI.WebControls.DropDownList
        Protected WithEvents rdEnterUrl As System.Web.UI.WebControls.RadioButton
        Protected WithEvents txtUrl As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblUserName As System.Web.UI.WebControls.Label
        Protected WithEvents txtUserName As System.Web.UI.WebControls.TextBox
        Protected WithEvents lblPassword As System.Web.UI.WebControls.Label
        Protected WithEvents txtPassword As System.Web.UI.WebControls.TextBox
        Protected WithEvents btnLoad As System.Web.UI.WebControls.Button
        Protected WithEvents lblMsg As System.Web.UI.WebControls.Label
        Protected WithEvents lblFeed As System.Web.UI.WebControls.Label
        Protected WithEvents dgAtomFeed As System.Web.UI.WebControls.DataGrid
        Protected WithEvents lblEntry As System.Web.UI.WebControls.Label
        Protected WithEvents dgEntry As System.Web.UI.WebControls.DataGrid

        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label

        Protected feed03 As AtomFeed03
        Private colAttribute As DataColumn
        Private colValue As DataColumn
        Private colTag As DataColumn
        Private dr As DataRow
        Private dtAtomFeeds As DataTable

        Private stringManager As New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly())
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            If Not IsPostBack Then
                fillURLs()
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                rdSelectUrl.Attributes.Add("OnClick", "return EnableDisableURLControls();")
                rdEnterUrl.Attributes.Add("OnClick", "return EnableDisableURLControls();")
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub
        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()

        End Sub
        Private Sub btnLoad_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoad.Click
            btnLoad.Attributes.Add("OnClick", "return checkURL();")

            Dim feed As AtomFeed = Nothing
            Try
                License.LoadLicense()
                If rdSelectUrl.Checked Then
                    feed = AtomFeed.Load(ddlURL.SelectedValue)
                    ddlURL.Enabled = True
                    txtUrl.Enabled = False
                    txtUrl.Text = stringManager.GetString("strHttp")
                Else
                    If rdEnterUrl.Checked Then
                        If Not txtUrl.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                            txtUrl.Text = "http://" + txtUrl.Text
                        End If
                        feed = AtomFeed.Load(txtUrl.Text, Nothing, Nothing)
                        txtUrl.Enabled = True
                        ddlURL.Enabled = False
                    End If
                    End If
                    Select Case feed.Version
                        Case AtomVersion.Atom03
                            dgAtomFeed.DataSource = DisplayFeed03(CType(feed, AtomFeed03))
                            dgAtomFeed.DataBind()
                            dgEntry.DataSource = DisplayEntry03(CType(feed, AtomFeed03))
                            dgEntry.DataBind()
                        Case AtomVersion.Atom10
                            dgAtomFeed.DataSource = DisplayFeed10(CType(feed, AtomFeed10))
                            dgAtomFeed.DataBind()
                            dgEntry.DataSource = DisplayEntry10(CType(feed, AtomFeed10))
                            dgEntry.DataBind()

                    End Select
                    lblFeed.Text = stringManager.GetString("strFeedGridTitle")
                    lblEntry.Text = stringManager.GetString("strEntryGridTitle")
                    dgAtomFeed.Visible = True
                    dgEntry.Visible = True
                lblMsg.Text = stringManager.GetString("strBlank")

                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")

                    Response.Write("<script language=javascript>window.navigate('#bm');</script>")
            Catch lex As AtomReaderException
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                If (lex.Message = stringManager.GetString("strUnlicensed")) Then
                    lblMsg.Text = stringManager.GetString("strLicenseException")
                Else
                    lblMsg.Text = stringManager.GetString("strErrorReading")
                End If
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                dgAtomFeed.Visible = False
                dgEntry.Visible = False

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = lex.Message
            Catch lex As InvalidLicenseException
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strLicenseException")
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                dgAtomFeed.Visible = False
                dgEntry.Visible = False

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = lex.Message
            Catch liex As InvalidLicenseInfoException
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                dgAtomFeed.Visible = False
                dgEntry.Visible = False

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                txtUrl.Enabled = False
                txtUrl.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = ex.Message
                lblFeed.Text = stringManager.GetString("strBlank")
                lblEntry.Text = stringManager.GetString("strBlank")
                dgAtomFeed.Visible = False
                dgEntry.Visible = False
                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub

        Public Function DisplayFeed03(ByVal feed03 As AtomFeed03) As DataTable
            dtAtomFeeds = New DataTable
            dtAtomFeeds.Locale = System.Globalization.CultureInfo.InvariantCulture
            colTag = New DataColumn("<b>Elements</b>", System.Type.GetType("System.String"))
            dtAtomFeeds.Columns.Add(colTag)
            colAttribute = New DataColumn("<b>Attributes</b>", System.Type.GetType("System.String"))
            dtAtomFeeds.Columns.Add(colAttribute)
            colValue = New DataColumn("<b>Value</b>", System.Type.GetType("System.String"))
            dtAtomFeeds.Columns.Add(colValue)
            insertDataRow("", "Version", "Atom 0.3")
            insertDataRow("", "xmlns", "http://purl.org/atom/ns#")
            If feed03.AdditionalElements.Count > 0 Then
                Dim se As ScopedElement = feed03.AdditionalElements(0)
                insertDataRow("", "xmlns " + se.NamespacePrefix, XMLEncoding(se.NamespaceUri.AbsoluteUri))
            Else
                For Each entry As AtomEntry03 In feed03.Entries
                    If entry.AdditionalElements.Count > 0 Then
                        Dim se As ScopedElement = entry.AdditionalElements(0)
                        If Not (se.NamespaceUri.AbsoluteUri.Length = 0) Then
                            insertDataRow("", "xmlns " + se.NamespacePrefix, XMLEncoding(se.NamespaceUri.AbsoluteUri))
                        End If

                    End If
                Next
            End If
            If Not (feed03.XmlLang = DefaultValues.Language) Then
                insertDataRow("", "Xml Language", Utility.ParseLanguage(feed03.XmlLang))
            End If
            If Not (feed03.Title.Content.Length = 0) Then
                insertDataRow("Title", "", XMLEncoding(feed03.Title.Content))
            End If
            If Not (feed03.Title.Mode = DefaultValues.Mode) Then
                insertDataRow("", "Mode", feed03.Title.Mode.ToString)
            End If
            If Not (feed03.Title.Type = DefaultValues.MediaType) Then
                insertDataRow("", "Type", Utility.ParseMediaType(feed03.Title.Type))
            End If
            For Each link As AtomLink In feed03.Links
                insertDataRow("Link", "", "")
                insertDataRow("", "Rel", Utility.ParseRelationship(link.Rel))
                insertDataRow("", "Type", Utility.ParseMediaType(link.Type))
                If Not (link.HRef Is DefaultValues.Uri) Then
                    insertDataRow("", "Href", XMLEncoding(link.HRef.AbsoluteUri))
                End If
                If Not (link.Title.Length = 0) Then
                    insertDataRow("", "Title", XMLEncoding(link.Title))
                End If
            Next
            If Not (feed03.Author Is Nothing) Then
                insertDataRow("Author", "", "")
                If Not (feed03.Author.Name.Length = 0) Then
                    insertDataRow("", "Name", XMLEncoding(feed03.Author.Name))
                End If
                If Not (feed03.Author.Url Is DefaultValues.Uri) Then
                    insertDataRow("", "Url", XMLEncoding((feed03.Author.Url.AbsoluteUri)))
                End If
                If Not (feed03.Author.Email.Length = 0) Then
                    insertDataRow("", "Email", XMLEncoding(feed03.Author.Email))
                End If
            End If
            If Not (feed03.Contributors Is Nothing) Then
                For Each contribute As AtomPersonConstruct In feed03.Contributors
                    insertDataRow("Contributor", "", "")
                    If Not (contribute.Name.Length = 0) Then
                        insertDataRow("", "Name", XMLEncoding(contribute.Name))
                    End If
                    If Not (contribute.Url Is DefaultValues.Uri) Then
                        insertDataRow("", "Url", XMLEncoding(contribute.Url.AbsoluteUri))
                    End If
                    If Not (contribute.Email.Length = 0) Then
                        insertDataRow("", "Email", XMLEncoding(contribute.Email))
                    End If
                Next
            End If
            If Not (feed03.Id Is DefaultValues.Uri) Then
                insertDataRow("Id", "", XMLEncoding(feed03.Id.AbsoluteUri))
            End If
            If Not (feed03.Copyright Is Nothing) Then
                If Not (feed03.Copyright.Content.Length = 0) Then
                    insertDataRow("Copyright", "", XMLEncoding(feed03.Copyright.Content))
                End If
                If Not (feed03.Copyright.Mode = DefaultValues.Mode) Then
                    insertDataRow("", "Mode", feed03.Copyright.Mode.ToString)
                End If
            End If
            If Not (feed03.Info Is Nothing) Then
                insertDataRow("Info", "", XMLEncoding(feed03.Info.Content))
                If Not (feed03.Info.Mode = DefaultValues.Mode) Then
                    insertDataRow("", "Mode", feed03.Info.Mode.ToString)
                End If
                If Not (feed03.Info.Type = DefaultValues.MediaType) Then
                    insertDataRow("", "Type", Utility.ParseMediaType(feed03.Info.Type))
                End If
            End If
            If Not (feed03.Modified Is Nothing) Then
                insertDataRow("Modified", "", ParseDate(feed03.Modified))
            End If
            If Not (feed03.Tagline Is Nothing) Then
                If Not (feed03.Tagline.Content.Length = 0) Then
                    insertDataRow("TagLine", "", XMLEncoding(feed03.Tagline.Content))
                End If
                If Not (feed03.Tagline.Mode = DefaultValues.Mode) Then
                    insertDataRow("", "Mode", feed03.Tagline.Mode.ToString)
                End If
                If Not (feed03.Tagline.Type = DefaultValues.MediaType) Then
                    insertDataRow("", "Type", Utility.ParseMediaType(feed03.Tagline.Type))
                End If
            End If
            Return dtAtomFeeds
        End Function

        Public Function DisplayFeed10(ByVal feed10 As AtomFeed10) As DataTable
            dtAtomFeeds = New DataTable
            dtAtomFeeds.Locale = System.Globalization.CultureInfo.InvariantCulture
            colTag = New DataColumn("<b>Elements</b>", System.Type.GetType("System.String"))
            dtAtomFeeds.Columns.Add(colTag)
            colAttribute = New DataColumn("<b>Attributes</b>", System.Type.GetType("System.String"))
            dtAtomFeeds.Columns.Add(colAttribute)
            colValue = New DataColumn("<b>Value</b>", System.Type.GetType("System.String"))
            dtAtomFeeds.Columns.Add(colValue)
            insertDataRow("", "Version", "Atom 1.0")
            insertDataRow("", "xmlns", "http://www.w3.org/2005/Atom")
            If Not (feed10.XmlLang = DefaultValues.Language) Then
                insertDataRow("", "Xml Language", Utility.ParseLanguage(feed10.XmlLang))
            End If
            If feed10.AdditionalElements.Count > 0 Then
                Dim se As ScopedElement = feed10.AdditionalElements(0)
                insertDataRow("", "xmlns " + se.NamespacePrefix, XMLEncoding(se.NamespaceUri.AbsoluteUri))
            Else
                For Each entry As AtomEntry10 In feed10.Entries
                    If entry.AdditionalElements.Count > 0 Then
                        Dim se As ScopedElement = entry.AdditionalElements(0)
                        If Not (se.NamespaceUri.AbsoluteUri.Length = 0) Then
                            insertDataRow("", "xmlns:" + se.NamespacePrefix, XMLEncoding(se.NamespaceUri.AbsoluteUri))
                        End If

                    End If
                Next
            End If
            If Not (feed10.Title.Content.Length = 0) Then
                insertDataRow("Title", "", XMLEncoding(feed10.Title.Content))
            End If
            If Not (feed10.Title.Type = DefaultValues.MediaType) Then
                insertDataRow("", "Type", Utility.ParseMediaType(feed10.Title.Type))
            End If
            If Not (feed10.Title.Mode = DefaultValues.Mode) Then
                insertDataRow("", "Mode", feed10.Title.Mode.ToString)
            End If
            If Not (feed10.Categories Is Nothing) Then
                For Each category As AtomCategoryConstruct In feed10.Categories
                    insertDataRow("Category", "", "")
                    insertDataRow("", "Term", XMLEncoding(category.Term))
                    insertDataRow("", "Label", XMLEncoding(category.Label))
                    insertDataRow("", "Scheme", XMLEncoding(category.Scheme.AbsoluteUri))
                Next
            End If
            If Not (feed10.Links Is Nothing) Then
                For Each link As AtomLink In feed10.Links
                    insertDataRow("Link", "", "")
                    insertDataRow("", "Rel", Utility.ParseRelationship(link.Rel))
                    insertDataRow("", "Type", Utility.ParseMediaType(link.Type))
                    If Not (link.HRef Is DefaultValues.Uri) Then
                        insertDataRow("", "Href", XMLEncoding(link.HRef.AbsoluteUri))
                    End If
                    If Not (link.HrefLang = DefaultValues.Language) Then
                        insertDataRow("", "HrefLang", Utility.ParseLanguage(link.HrefLang))
                    End If
                    If Not (link.Length = -1) Then
                        insertDataRow("", "Length", link.Length.ToString)
                    End If
                    If Not (link.Title.Length = 0) Then
                        insertDataRow("", "Title", XMLEncoding(link.Title))
                    End If
                Next
            End If
            If Not (feed10.Authors Is Nothing) Then
                For Each author As AtomPersonConstruct In feed10.Authors
                    insertDataRow("Author", "", "")
                    If Not (author.Name.Length = 0) Then
                        insertDataRow("", "Name", XMLEncoding(author.Name))
                    End If
                    If Not (author.Uri Is DefaultValues.Uri) Then
                        insertDataRow("", "Uri", XMLEncoding(author.Uri.AbsoluteUri))
                    End If
                    If author.Email.Length >= 45 Then
                        insertDataRow("", "Email", XMLEncoding(author.Email))
                    Else
                        If Not (author.Email.Length = 0) Then
                            insertDataRow("", "Email", XMLEncoding(author.Email))
                        End If
                    End If
                Next
            End If
            If Not (feed10.Contributors Is Nothing) Then
                For Each contribute As AtomPersonConstruct In feed10.Contributors
                    insertDataRow("Contributor", "", "")
                    If Not (contribute.Name.Length = 0) Then
                        insertDataRow("", "Name", XMLEncoding(contribute.Name))
                    End If
                    If Not (contribute.Uri Is DefaultValues.Uri) Then
                        insertDataRow("", "Uri", XMLEncoding(contribute.Uri.AbsoluteUri))
                    End If
                    If Not (contribute.Email.Length = 0) Then
                        insertDataRow("", "Email", XMLEncoding(contribute.Email))
                    End If
                Next
            End If
            If Not (feed10.Id Is DefaultValues.Uri) Then
                insertDataRow("Id", "", XMLEncoding(feed10.Id.AbsoluteUri))
            End If
            If Not (feed10.Icon Is Nothing) Then
                If Not (feed10.Icon.Content.Length = 0) Then
                    insertDataRow("Icon", "", XMLEncoding(feed10.Icon.Content))
                End If
            End If
            If Not (feed10.Logo Is Nothing) Then
                If Not (feed10.Logo.Content.Length = 0) Then
                    insertDataRow("Logo", "", XMLEncoding(feed10.Logo.Content))
                End If
            End If
            If Not (feed10.Rights Is Nothing) Then
                If Not (feed10.Rights.Content.Length = 0) Then
                    insertDataRow("Rights", "", XMLEncoding(feed10.Rights.Content))
                End If
                If Not (feed10.Rights.Mode = DefaultValues.Mode) Then
                    insertDataRow("", "Mode", feed10.Rights.Mode.ToString)
                End If
                If Not (feed10.Rights.Type = DefaultValues.MediaType) Then
                    insertDataRow("", "Type", Utility.ParseMediaType(feed10.Rights.Type))
                End If
            End If
            If Not (feed10.Updated Is Nothing) Then
                insertDataRow("Updated", "", ParseDate(feed10.Updated))
            End If
            If Not (feed10.Subtitle Is Nothing) Then
                If Not (feed10.Subtitle.Content.Length = 0) Then
                    insertDataRow("SubTitle", "", XMLEncoding(feed10.Subtitle.Content))
                End If
                If Not (feed10.Subtitle.Mode = DefaultValues.Mode) Then
                    insertDataRow("", "Mode", feed10.Subtitle.Mode.ToString)
                End If
                If Not (feed10.Subtitle.Type = DefaultValues.MediaType) Then
                    insertDataRow("", "Type", Utility.ParseMediaType(feed10.Subtitle.Type))
                End If
            End If
            Return dtAtomFeeds
        End Function

        Private Function DisplayEntry03(ByVal feed03 As AtomFeed03) As DataTable
            dtAtomFeeds.Clear()
            For Each entry As AtomEntry03 In feed03.Entries
                If Not (entry.Title.Content.Length = 0) Then
                    insertDataRow("Title", "", XMLEncoding(entry.Title.Content))
                End If
                If Not (entry.Title.Mode = DefaultValues.Mode) Then
                    insertDataRow("", "Mode", entry.Title.Mode.ToString)
                End If
                If Not (entry.Title.Type = DefaultValues.MediaType) Then
                    insertDataRow("", "Type", Utility.ParseMediaType(entry.Title.Type))
                End If
                If Not (entry.Links Is Nothing) Then
                    For Each link As AtomLink In entry.Links
                        insertDataRow("Link", "", "")
                        insertDataRow("", "Rel", Utility.ParseRelationship(link.Rel))
                        insertDataRow("", "Type", Utility.ParseMediaType(link.Type))
                        If Not (link.HRef Is DefaultValues.Uri) Then
                            insertDataRow("", "Href", XMLEncoding(link.HRef.AbsoluteUri))
                        End If
                        If Not (link.Title.Length = 0) Then
                            insertDataRow("", "Title", XMLEncoding(link.Title))
                        End If
                    Next
                End If
                If Not (entry.Author Is Nothing) Then
                    insertDataRow("Author", "", "")
                    If Not (entry.Author.Name.Length = 0) Then
                        insertDataRow("", "Name", XMLEncoding(entry.Author.Name))
                    End If
                    If Not (entry.Author.Uri Is DefaultValues.Uri) Then
                        insertDataRow("", "Url", XMLEncoding(entry.Author.Url.AbsoluteUri))
                    End If
                    If Not (entry.Author.Email.Length = 0) Then
                        insertDataRow("", "Email", XMLEncoding(entry.Author.Email))
                    End If
                End If
                If Not (entry.Contributors Is Nothing) Then
                    For Each contribute As AtomPersonConstruct In entry.Contributors
                        insertDataRow("Contribute", "", "")
                        If Not (contribute.Name.Length = 0) Then
                            insertDataRow("", "Name", XMLEncoding(contribute.Name))
                        End If
                        If Not (contribute.Url Is DefaultValues.Uri) Then
                            insertDataRow("", "Url", XMLEncoding(contribute.Url.AbsoluteUri))
                        End If
                        If Not (contribute.Email.Length = 0) Then
                            insertDataRow("", "Email", XMLEncoding(contribute.Email))
                        End If
                    Next
                End If
                If Not (entry.Id Is DefaultValues.Uri) Then
                    If Not (entry.Id.AbsoluteUri.Length = 0) Then
                        insertDataRow("Id", "", XMLEncoding(entry.Id.AbsoluteUri))
                    End If
                End If
                If Not (entry.Modified Is Nothing) Then
                    insertDataRow("Modified", "", ParseDate(entry.Modified))
                End If
                If Not (entry.Issued Is Nothing) Then
                    insertDataRow("Issued", "", ParseDate(entry.Issued))
                End If
                If Not (entry.Created Is Nothing) Then
                    insertDataRow("Created", "", ParseDate(entry.Created))
                End If
                If Not (entry.Summary Is Nothing) Then
                    If Not (entry.Summary.Content.Length = 0) Then
                        insertDataRow("Summary", "", XMLEncoding(entry.Summary.Content))
                    End If
                    If Not (entry.Summary.Type = DefaultValues.MediaType) Then
                        insertDataRow("", "Type", Utility.ParseMediaType(entry.Summary.Type))
                    End If
                    If Not (entry.Summary.Mode = DefaultValues.Mode) Then
                        insertDataRow("", "Mode", entry.Summary.Mode.ToString)
                    End If
                End If
                If Not (entry.Contents Is Nothing) Then
                    For Each content As AtomContent In entry.Contents
                        insertDataRow("Content", "", XMLEncoding(content.Content))
                        If Not (content.Type = DefaultValues.MediaType) Then
                            insertDataRow("", "Type", Utility.ParseMediaType(content.Type))
                        End If
                        If Not (content.Mode = DefaultValues.Mode) Then
                            insertDataRow("", "Mode", content.Mode.ToString)
                        End If
                    Next
                End If
                If Not (entry.AdditionalElements Is Nothing) Then
                    For Each scoped As ScopedElement In entry.AdditionalElements
                        If Not (scoped.NamespacePrefix.Length = 0) Then
                            If Not (scoped.Content.Length = 0) Then
                                insertDataRow("", XMLEncoding(scoped.NamespacePrefix) + ":" + scoped.LocalName, XMLEncoding(scoped.Content))
                            End If
                        End If
                    Next
                End If
                Exit For
            Next
            Return dtAtomFeeds
        End Function

        Private Function DisplayEntry10(ByVal feed10 As AtomFeed10) As DataTable
            dtAtomFeeds.Clear()
            For Each entry As AtomEntry10 In feed10.Entries
                If Not (entry.Title.Content.Length = 0) Then
                    insertDataRow("Title", "", XMLEncoding(entry.Title.Content))
                End If
                If Not (entry.Title.Mode = DefaultValues.Mode) Then
                    insertDataRow("", "Mode", entry.Title.Mode.ToString)
                End If
                If Not (entry.Title.Type = DefaultValues.MediaType) Then
                    insertDataRow("", "Type", Utility.ParseMediaType(entry.Title.Type))
                End If
                For Each link As AtomLink In entry.Links
                    insertDataRow("Link", "", "")
                    insertDataRow("", "Rel", Utility.ParseRelationship(link.Rel))
                    insertDataRow("", "Type", Utility.ParseMediaType(link.Type))
                    If Not (link.HRef Is DefaultValues.Uri) Then
                        insertDataRow("", "Href", XMLEncoding(link.HRef.AbsoluteUri))
                    End If
                    If Not (link.Title.Length = 0) Then
                        insertDataRow("", "Title", XMLEncoding(link.Title))
                    End If
                    If Not (link.Length = -1) Then
                        insertDataRow("", "Length", link.Length.ToString)
                    End If
                    If Not (link.HrefLang = DefaultValues.Language) Then
                        insertDataRow("", "Launguage", Utility.ParseLanguage(link.HrefLang))
                    End If
                Next
                If Not (entry.Categories Is Nothing) Then
                    For Each category As AtomCategoryConstruct In entry.Categories
                        insertDataRow("Category", "", "")
                        If Not (category.Term.Length = 0) Then
                            insertDataRow("", "Term", category.Term)
                        End If
                        If Not (category.Scheme Is DefaultValues.Uri) Then
                            insertDataRow("", "Scheme", XMLEncoding(category.Scheme.AbsoluteUri))
                        End If
                        If Not (category.Label.Length = 0) Then
                            insertDataRow("", "Label", category.Label)
                        End If
                    Next
                End If
                If Not (entry.Authors Is Nothing) Then
                    For Each author As AtomPersonConstruct In entry.Authors
                        insertDataRow("Author", "", "")
                        If Not (author.Name.Length = 0) Then
                            insertDataRow("", "Name", XMLEncoding(author.Name))
                        End If
                        If Not (author.Uri Is DefaultValues.Uri) Then
                            insertDataRow("", "Uri", XMLEncoding(author.Uri.AbsoluteUri))
                        End If
                        If Not (author.Email.Length = 0) Then
                            insertDataRow("", "Email", XMLEncoding(author.Email))
                        End If
                    Next
                End If
                If Not (entry.Contributors Is Nothing) Then
                    For Each contribute As AtomPersonConstruct In entry.Contributors
                        insertDataRow("Contribute", "", "")
                        If Not (contribute.Name.Length = 0) Then
                            insertDataRow("", "Name", contribute.Name)
                        End If
                        If Not (contribute.Uri Is DefaultValues.Uri) Then
                            insertDataRow("", "Url", XMLEncoding(contribute.Uri.AbsoluteUri))
                        End If
                        If Not (contribute.Email.Length = 0) Then
                            insertDataRow("", "Email", XMLEncoding(contribute.Email))
                        End If
                    Next
                    If Not (entry.Updated Is Nothing) Then
                        insertDataRow("Updated", "", ParseDate(entry.Updated))
                    End If
                    If Not (entry.Id Is DefaultValues.Uri) Then
                        If Not (entry.Id.AbsoluteUri.Length = 0) Then
                            insertDataRow("Id", "", XMLEncoding(entry.Id.AbsoluteUri))
                        End If
                    End If
                    If Not (entry.Published Is Nothing) Then
                        insertDataRow("Published", "", ParseDate(entry.Published))
                    End If
                    If Not (entry.Summary Is Nothing) Then
                        insertDataRow("Summary", "", XMLEncoding(entry.Summary.Content))
                        If Not (entry.Summary.Type = DefaultValues.MediaType) Then
                            insertDataRow("", "Type", Utility.ParseMediaType(entry.Summary.Type))
                        End If
                        If Not (entry.Summary.Mode = DefaultValues.Mode) Then
                            insertDataRow("", "Mode", entry.Summary.Mode.ToString)
                        End If
                    End If
                    If Not (entry.Content.Content.Length = 0) Then
                        insertDataRow("Content", "", XMLEncoding(entry.Content.Content))
                        If Not (entry.Content.Type = DefaultValues.MediaType) Then
                            insertDataRow("", "Type", Utility.ParseMediaType(entry.Content.Type))
                        End If
                        If Not (entry.Content.Mode = DefaultValues.Mode) Then
                            insertDataRow("", "Mode", entry.Content.Mode.ToString)
                        End If
                    End If
                    If Not (entry.Rights Is Nothing) Then
                        If Not (entry.Rights.Content.Length = 0) Then
                            insertDataRow("Rights", "", XMLEncoding(entry.Rights.Content))
                        End If
                    End If
                    If Not (entry.Source Is Nothing) Then
                        For Each source As AtomSourceConstruct In entry.Source
                            insertDataRow("Source", "", "")
                            If Not (source.Id Is DefaultValues.Uri) Then
                                If Not (source.Id.AbsoluteUri.Length = 0) Then
                                    insertDataRow("", "Id", XMLEncoding(source.Id.AbsoluteUri))
                                End If
                            End If
                            If Not (source.Rights.Length = 0) Then
                                insertDataRow("", "Rights", source.Rights)
                            End If
                            If Not (source.Title.Length = 0) Then
                                insertDataRow("", "Title", XMLEncoding(source.Title))
                            End If
                            If Not (source.Updated.DateTime.ToString Is Nothing) Then
                                insertDataRow("", "Updated", ParseDate(source.Updated))
                            End If
                        Next
                    End If
                    If Not (entry.AdditionalElements Is Nothing) Then
                        For Each scoped As ScopedElement In entry.AdditionalElements
                            If Not (scoped.NamespacePrefix.Length = 0) Then
                                If scoped.Content.Length > 45 Then
                                    insertDataRow(XMLEncoding(scoped.NamespacePrefix), "", scoped.LocalName)
                                    insertDataRow(XMLEncoding(scoped.Content), "", "")
                                Else
                                    If Not (scoped.Content.Length = 0) Then
                                        insertDataRow(XMLEncoding(scoped.NamespacePrefix), "", scoped.LocalName)
                                        insertDataRow(XMLEncoding(scoped.Content), "", "")
                                    End If
                                End If
                            End If
                        Next
                    End If
                End If
                Exit For
            Next
            Return dtAtomFeeds
        End Function

        Private Sub dgAtomFeed_ItemCreated(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles dgAtomFeed.ItemCreated
            If e.Item.ItemType = ListItemType.Item OrElse e.Item.ItemType = ListItemType.AlternatingItem Then
                e.Item.Cells(0).Width = Unit.Percentage(15)
                e.Item.Cells(0).BackColor = System.Drawing.Color.Cornsilk
                e.Item.Cells(1).Width = Unit.Percentage(15)
                e.Item.Cells(1).ForeColor = System.Drawing.Color.Blue
                e.Item.Cells(2).Width = Unit.Percentage(70)
                e.Item.Cells(2).ForeColor = System.Drawing.Color.Red
            End If
        End Sub

        Private Sub dgEntry_ItemCreated(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles dgEntry.ItemCreated
            If e.Item.ItemType = ListItemType.Item OrElse e.Item.ItemType = ListItemType.AlternatingItem Then
                e.Item.Cells(0).Width = Unit.Percentage(15)
                e.Item.Cells(0).BackColor = System.Drawing.Color.Cornsilk
                e.Item.Cells(1).Width = Unit.Percentage(15)
                e.Item.Cells(1).ForeColor = System.Drawing.Color.Blue
                e.Item.Cells(2).Width = Unit.Percentage(70)
                e.Item.Cells(2).ForeColor = System.Drawing.Color.Red
            End If
        End Sub

        Private Function ParseDate(ByVal dtDate As AtomDateConstruct) As String
            Dim providerCulture As System.IFormatProvider = System.Globalization.CultureInfo.CurrentCulture
            Dim utcOffset As String = String.Empty
            Dim sign As String = String.Empty
            If (System.TimeSpan.Equals(dtDate.UtcOffset, DefaultValues.UtcOffset)) Then
                utcOffset = "Z"
            Else
                utcOffset = dtDate.UtcOffset.ToString.Substring(0, dtDate.UtcOffset.ToString.Length - 3)
                sign = "+"
                If utcOffset.Substring(0, 1).Equals("-") Then
                    sign = String.Empty
                End If
            End If
            Dim dateTime As String = dtDate.DateTime.ToString("s", providerCulture)
            Dim tempStr As String = String.Format(providerCulture, "{0}{1}{2}", dateTime, sign, utcOffset)
            Return tempStr
        End Function

        Private Sub insertDataRow(ByVal strTag As String, ByVal strAttribute As String, ByVal strValue As String)
            dr = dtAtomFeeds.NewRow
            dr(colTag) = strTag
            dr(colAttribute) = strAttribute
            dr(colValue) = strValue
            dtAtomFeeds.Rows.Add(dr)
        End Sub

        Private Sub fillURLs()
            ddlURL.Items.Add(New ListItem("http://feedreader:123@test.web20tools.net/samples/atom/Protected/atom10.xml", "http://feedreader:123@test.web20tools.net/samples/atom/Protected/atom10.xml"))
        End Sub

        Private Function XMLEncoding(ByVal stitle As String) As String
            Dim strBuild As New StringBuilder(stitle)
            strBuild.Replace("&amp;", "").Replace("&apos;", "'").Replace("&quot;", """").Replace("&lt;", "<").Replace("&gt;", ">").Replace("" & Microsoft.VisualBasic.Chr(10) & "", "").Replace("" & Microsoft.VisualBasic.Chr(13) & "", "")
            Return strBuild.ToString.Trim
        End Function
    End Class
End Namespace
