' AtomFeedDataset.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.

Imports System
Imports System.Collections 
Imports System.ComponentModel 
Imports System.Data 
Imports System.Drawing 
Imports System.Web 
Imports System.Web.SessionState 
Imports System.Web.UI 
Imports System.Web.UI.WebControls 
Imports System.Web.UI.HtmlControls 
Imports System.Data.SqlClient 
Imports Web20Tools.Feed.Atom
Imports System.Resources
Imports System.Reflection
Imports Web20Tools.Feed
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework

Namespace Samples.Atom
    ''' <summary>
    ''' Create an ATOM Feed from a DataSet
    ''' </summary>
    Public Class AtomFeedDataset
        Inherits System.Web.UI.Page
        Protected WithEvents Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected WithEvents lblCreated As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXMLtop As System.Web.UI.WebControls.HyperLink
        Protected WithEvents ddlVersions As System.Web.UI.WebControls.DropDownList
        Protected WithEvents txtConnection As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtFeedQuery As System.Web.UI.WebControls.TextBox
        Protected WithEvents txtEntriesQuery As System.Web.UI.WebControls.TextBox
        Protected WithEvents btnSave As System.Web.UI.WebControls.Button
        Protected WithEvents lblMsg As System.Web.UI.WebControls.Label
        Protected WithEvents lblCreatedBottom As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXML As System.Web.UI.WebControls.HyperLink
        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label

        Private stringManager As New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly())
        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

            If Not IsPostBack Then
                loadAttributes()
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub
        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub
        Private Sub InitializeComponent()

        End Sub
        Private Sub fillVersions()
            ddlVersions.Items.Add("Atom 0.3")
            ddlVersions.Items.Add("Atom 1.0")
        End Sub
        Private Sub loadAttributes()
            fillVersions()
            ddlVersions.Attributes.Add("OnChange", "changeDropdown();")
            txtConnection.Text = stringManager.GetString("strConnectionString")
            txtFeedQuery.Text = stringManager.GetString("strFeedQuery")
            txtEntriesQuery.Text = stringManager.GetString("strEntryQuery")
        End Sub
        Private Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
            Try
                License.LoadLicense()
                Dim con As SqlConnection = New SqlConnection(txtConnection.Text)
                con.Open()
                Dim sqlAdp As SqlDataAdapter = New SqlDataAdapter(txtFeedQuery.Text, con)
                Dim dsFeed As DataSet = New DataSet
                dsFeed.Locale = System.Globalization.CultureInfo.InvariantCulture
                sqlAdp.Fill(dsFeed)
                sqlAdp = New SqlDataAdapter(txtEntriesQuery.Text, con)
                Dim dsEntry As DataSet = New DataSet
                dsEntry.Locale = System.Globalization.CultureInfo.InvariantCulture
                sqlAdp.Fill(dsEntry)
                If ddlVersions.SelectedItem.Text.Equals("Atom 1.0") Then
                    saveAtom10(dsFeed, dsEntry)
                Else
                    saveAtom03(dsFeed, dsEntry)
                End If
                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
            Catch ex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            Catch liex As InvalidLicenseInfoException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strErrorCreating")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub
        Private Sub saveAtom10(ByVal dsFeed As DataSet, ByVal dsEntry As DataSet)
            Try
                Dim objAtomFeed10 As AtomFeed10 = New AtomFeed10
                Dim feedLink As AtomLink = New AtomLink
                Dim objAuthor As AtomPersonConstruct = New AtomPersonConstruct
                Dim objFeedUpdated As AtomDateConstruct = New AtomDateConstruct
                Dim i As Integer = 0
                While i < dsFeed.Tables(0).Rows.Count
                    Dim objFeedTitle As AtomContentConstruct = New AtomContentConstruct("Title", dsFeed.Tables(0).Rows(0)("Title").ToString)
                    objAtomFeed10.Title = objFeedTitle
                    feedLink.HRef = New FeedUri(dsFeed.Tables(0).Rows(0)("Link").ToString)
                    objAtomFeed10.Links.Add(feedLink)
                    objFeedUpdated.DateTime = Convert.ToDateTime(dsFeed.Tables(0).Rows(0)("Updated").ToString)
                    objAtomFeed10.Updated = objFeedUpdated
                    objAuthor.Name = dsFeed.Tables(0).Rows(0)("Author").ToString
                    objAtomFeed10.Authors.Add(objAuthor)

                    Dim Uri As Web20Tools.Feed.FeedUri
                    Uri = New FeedUri(dsFeed.Tables(0).Rows(0)("Id").ToString)
                    objAtomFeed10.Id = Uri
                    System.Math.Min(System.Threading.Interlocked.Increment(i), i - 1)
                End While
                While i < dsEntry.Tables(0).Rows.Count
                    Dim objAtomEntry10 As AtomEntry10 = New AtomEntry10
                    Dim objEntryTitle As AtomContentConstruct = New AtomContentConstruct("Title", dsEntry.Tables(0).Rows(i)("Title").ToString)
                    objAtomEntry10.Title = objEntryTitle
                    Dim entryLink As AtomLink = New AtomLink
                    entryLink.HRef = New FeedUri(dsEntry.Tables(0).Rows(i)("Link").ToString)
                    objAtomEntry10.Links.Add(entryLink)
                    objFeedUpdated.DateTime = Convert.ToDateTime(dsEntry.Tables(0).Rows(i)("Updated").ToString)
                    objAtomEntry10.Updated = objFeedUpdated
                    Dim objEntrySummary As AtomContentConstruct = New AtomContentConstruct("summary", dsEntry.Tables(0).Rows(i)("Summary").ToString)
                    objAtomEntry10.Summary = objEntrySummary
                    objAtomFeed10.Entries.Add(objAtomEntry10)

                    Dim Uri As Web20Tools.Feed.FeedUri
                    Uri = New FeedUri(dsEntry.Tables(0).Rows(0)("Id").ToString)
                    objAtomEntry10.Id = Uri
                    System.Math.Min(System.Threading.Interlocked.Increment(i), i - 1)
                End While
                Session.Add("AtomFeed", objAtomFeed10)

                lblCreated.Text = stringManager.GetString("strCreated")
                lblCreatedBottom.Text = stringManager.GetString("strCreated")
                hlOpenXML.Text = stringManager.GetString("strClick")
                hlOpenXMLtop.Text = stringManager.GetString("strClick")
                hlOpenXML.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXML.Target = "_blank"
                hlOpenXMLtop.Target = "_blank"
                lblMsg.Text = stringManager.GetString("strBlank")
            Catch ex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")
                Session("AtomFeed") = Nothing
            Catch
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strErrorCreating")
                Session("AtomFeed") = Nothing
            End Try
        End Sub
        Private Sub saveAtom03(ByVal dsFeed As DataSet, ByVal dsEntry As DataSet)
            Try
                Dim objAtomFeed03 As AtomFeed03 = New AtomFeed03
                Dim feedLink As AtomLink = New AtomLink
                Dim objAuthor As AtomPersonConstruct = New AtomPersonConstruct
                Dim objFeedModified As AtomDateConstruct = New AtomDateConstruct
                Dim i As Integer = 0
                While i < dsFeed.Tables(0).Rows.Count
                    Dim objFeedTitle As AtomContentConstruct = New AtomContentConstruct("Title", dsFeed.Tables(0).Rows(0)("Title").ToString)
                    objAtomFeed03.Title = objFeedTitle
                    feedLink.HRef = New FeedUri(dsFeed.Tables(0).Rows(0)("Link").ToString)
                    objAtomFeed03.Links.Add(feedLink)
                    objFeedModified.DateTime = Convert.ToDateTime(dsFeed.Tables(0).Rows(0)("Updated").ToString)
                    objAtomFeed03.Modified = objFeedModified
                    objAuthor.Name = dsFeed.Tables(0).Rows(0)("Author").ToString
                    objAtomFeed03.Author = objAuthor
                    Dim Uri As Web20Tools.Feed.FeedUri
                    Uri = New FeedUri(dsFeed.Tables(0).Rows(0)("Id").ToString)
                    objAtomFeed03.Id = Uri
                    System.Math.Min(System.Threading.Interlocked.Increment(i), i - 1)
                End While

                While i < dsEntry.Tables(0).Rows.Count
                    Dim objAtomEntry03 As AtomEntry03 = New AtomEntry03
                    Dim objEntryTitle As AtomContentConstruct = New AtomContentConstruct("Title", dsEntry.Tables(0).Rows(i)("Title").ToString)
                    objAtomEntry03.Title = objEntryTitle
                    Dim entryLink As AtomLink = New AtomLink
                    entryLink.HRef = New FeedUri(dsEntry.Tables(0).Rows(i)("Link").ToString)
                    objAtomEntry03.Links.Add(entryLink)
                    objFeedModified.DateTime = Convert.ToDateTime(dsEntry.Tables(0).Rows(i)("Updated").ToString)
                    objAtomEntry03.Modified = objFeedModified
                    objFeedModified.DateTime = Convert.ToDateTime(dsEntry.Tables(0).Rows(i)("Updated").ToString)
                    objAtomEntry03.Issued = objFeedModified
                    Dim objEntrySummary As AtomContentConstruct = New AtomContentConstruct("summary", dsEntry.Tables(0).Rows(i)("Summary").ToString)
                    objAtomEntry03.Summary = objEntrySummary
                    Dim Uri As Web20Tools.Feed.FeedUri
                    Uri = New FeedUri(dsEntry.Tables(0).Rows(0)("Id").ToString)
                    objAtomEntry03.Id = Uri
                    objAtomFeed03.Entries.Add(objAtomEntry03)
                    System.Math.Min(System.Threading.Interlocked.Increment(i), i - 1)
                End While
                Session.Add("AtomFeed", objAtomFeed03)
                lblCreated.Text = stringManager.GetString("strCreated")
                lblCreatedBottom.Text = stringManager.GetString("strCreated")
                hlOpenXML.Text = stringManager.GetString("strClick")
                hlOpenXMLtop.Text = stringManager.GetString("strClick")
                hlOpenXML.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXMLtop.NavigateUrl = "AtomShowFeed.aspx"
                hlOpenXML.Target = "_blank"
                hlOpenXMLtop.Target = "_blank"
                lblMsg.Text = stringManager.GetString("strBlank")
            Catch ex As InvalidLicenseException
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXML.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strLicenseException")
                Session("AtomFeed") = Nothing
            Catch
                lblCreated.Text = stringManager.GetString("strBlank")
                lblCreatedBottom.Text = stringManager.GetString("strBlank")
                hlOpenXMLtop.Text = stringManager.GetString("strBlank")
                lblMsg.Text = stringManager.GetString("strErrorCreating")
                Session("AtomFeed") = Nothing
            End Try
        End Sub

    End Class
End Namespace
