' AtomStream.aspx.vb
' Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved.

Imports System
Imports System.Collections 
Imports System.ComponentModel 
Imports System.Data 
Imports System.Drawing 
Imports System.Web 
Imports System.Web.SessionState 
Imports System.Web.UI 
Imports System.Web.UI.WebControls 
Imports System.Web.UI.HtmlControls 
Imports System.Net 
Imports System.IO 
Imports Web20Tools.Feed.Atom
Imports System.Resources
Imports System.Reflection
Imports Web20Tools.Security
Imports Web20Tools.ExceptionFramework

Namespace Samples.Atom
    ''' <summary>
    ''' Write an ATOM Feed to an HTTP Response Stream
    ''' </summary>
    Public Class AtomStream
        Inherits System.Web.UI.Page
        Protected WithEvents Form1 As System.Web.UI.HtmlControls.HtmlForm
        Protected WithEvents rdSelectUrl As System.Web.UI.WebControls.RadioButton
        Protected WithEvents ddlURL As System.Web.UI.WebControls.DropDownList
        Protected WithEvents rdEnterUrl As System.Web.UI.WebControls.RadioButton
        Protected WithEvents txtURL As System.Web.UI.WebControls.TextBox
        Protected WithEvents btnCreate As System.Web.UI.WebControls.Button
        Protected WithEvents lblMsg As System.Web.UI.WebControls.Label
        Protected WithEvents hlOpenXML As System.Web.UI.WebControls.HyperLink

        Protected lblFeed As System.Web.UI.WebControls.Label
        Protected dgAtomFeed As System.Web.UI.WebControls.DataGrid
        Protected lblEntry As System.Web.UI.WebControls.Label
        Protected dgEntry As System.Web.UI.WebControls.DataGrid

        Protected hlViewError As System.Web.UI.WebControls.HyperLink
        Protected lblError As System.Web.UI.WebControls.Label

        Private stringManager As New ResourceManager("Samples.SamplesResource", [Assembly].GetExecutingAssembly())

        Private Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)

            If Not IsPostBack Then
                fillURLs()
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdSelectUrl.Attributes.Add("OnClick", "return EnableDiableURLControls();")
                rdEnterUrl.Attributes.Add("OnClick", "return EnableDiableURLControls();")
                hlViewError.Attributes.Add("OnClick", "return ShowError();")
            End If
        End Sub

        Protected Overloads Overrides Sub OnInit(ByVal e As EventArgs)
            InitializeComponent()
            MyBase.OnInit(e)
        End Sub

        Private Sub InitializeComponent()
            AddHandler Me.btnCreate.Click, AddressOf Me.btnCreate_Click
            AddHandler Me.Load, AddressOf Me.Page_Load
        End Sub

        Private Sub btnCreate_Click(ByVal sender As Object, ByVal e As System.EventArgs)
            Try
                License.LoadLicense()
                Dim feed As AtomFeed
                lblMsg.Text = String.Empty
                If rdSelectUrl.Checked Then
                    feed = AtomFeed.Load(ddlURL.SelectedValue)
                    ddlURL.Enabled = True
                    txtURL.Enabled = False
#If VS8 Then
                    ClientScript.RegisterClientScriptBlock(Type.GetType("System.String"), "", "<script language='javascript'>window.open('AtomShowStream.aspx?url=" + ddlURL.SelectedValue + "');</script>")
#Else
                    Page.RegisterClientScriptBlock("", "<script language='javascript'>window.open('AtomShowStream.aspx?url=" + ddlURL.SelectedValue + "');</script>")
#End If
                Else
                    If Not txtURL.Text.ToUpper().StartsWith("http://".ToUpper()) Then
                        txtURL.Text = "http://" + txtURL.Text
                    End If
                    feed = AtomFeed.Load(txtURL.Text)
                    txtURL.Enabled = True
                    ddlURL.Enabled = False
#If VS8 Then
                    ClientScript.RegisterClientScriptBlock(Type.GetType("System.String"), "", "<script language='javascript'>window.open('AtomShowStream.aspx?url=" + txtURL.Text + "');</script>")
#Else
                    Page.RegisterClientScriptBlock("", "<script language='javascript'>window.open('AtomShowStream.aspx?url=" + txtURL.Text + "');</script>")
#End If
                End If

                hlViewError.Text = stringManager.GetString("strBlank")
                hlViewError.NavigateUrl = stringManager.GetString("strBlank")
                lblError.Text = stringManager.GetString("strBlank")
            Catch ex As AtomReaderException
                hlOpenXML.Text = stringManager.GetString("strBlank")
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                If (ex.Message = stringManager.GetString("strUnlicensed")) Then
                    lblMsg.Text = stringManager.GetString("strLicenseException")
                Else
                    lblMsg.Text = stringManager.GetString("strErrorReading")
                End If

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            Catch lex As InvalidLicenseException
                hlOpenXML.Text = stringManager.GetString("strBlank")
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strLicenseException")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = lex.Message
            Catch liex As InvalidLicenseInfoException
                hlOpenXML.Text = stringManager.GetString("strBlank")
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strInvalidLicenseInfo")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = liex.Message
            Catch ex As Exception
                hlOpenXML.Text = stringManager.GetString("strBlank")
                txtURL.Enabled = False
                txtURL.Text = stringManager.GetString("strHttp")
                rdSelectUrl.Checked = True
                rdEnterUrl.Checked = False
                lblMsg.Text = stringManager.GetString("strErrorCreating")

                hlViewError.Text = stringManager.GetString("strViewError")
                hlViewError.NavigateUrl = "#"
                lblError.Text = ex.Message
            End Try
        End Sub

        Private Sub fillURLs()
            ddlURL.Items.Add(New ListItem(stringManager.GetString("strAtom03Url"), stringManager.GetString("strAtom03Url")))
            ddlURL.Items.Add(New ListItem(stringManager.GetString("strAtom10Url"), stringManager.GetString("strAtom10Url")))
        End Sub
    End Class
End Namespace
