/*
	* Atom03.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
*/

using System;
using System.Text;
using System.Text.RegularExpressions;
using Web20Tools.Feed.Atom;

namespace AtomConvert
{ 
	public class Atom03
    {
        private StringBuilder strData;
        private const int range = 45;

        #region CheckUrl
        public static bool CheckUrl(string surl)
        {
            if (surl != null)
            {
                Regex RgxUrl = new Regex("(([a-zA-Z][0-9a-zA-Z+\\-\\.]*:)?/{0,2}[0-9a-zA-Z;/?:@&=+$\\.\\-_!~*'()%]+)?(#[0-9a-zA-Z;/?:@&=+$\\.\\-_!~*'()%]+)?");

                if (!RgxUrl.IsMatch(surl))
                {
                    return false;
                }
                else
                {
                    return true;

                }
            }
            else
            {
                return false;
            }
        }
        #endregion
  
        #region Feed
            public string DisplayFeed03(AtomFeed03 feed03)
            {
                strData = new StringBuilder();
                strData.Append("Feed  " + Environment.NewLine);
                if (feed03.Version.ToString() == "Atom03")
                {
                    strData.Append(" Version\t: Atom 0.3" + Environment.NewLine);
                }
                strData.Append(" xmlns\t\t: http://purl.org/atom/ns# " + Environment.NewLine);                 

                if (feed03.AdditionalElements.Count > 0)
                {
                    ScopedElement se = feed03.AdditionalElements[0];
                    strData.Append(" xmlns:" + se.NamespacePrefix + "\t\t: " + XMLEncoding(se.NamespaceUri.AbsoluteUri.Substring(0,range) + "..."));
                    strData.Append(Environment.NewLine);
                }
                else
                {
                    foreach (AtomEntry03 entry in feed03.Entries)
                    {
                        if (entry.AdditionalElements.Count > 0)
                        {
                            ScopedElement se = entry.AdditionalElements[0];
                            if (se.NamespaceUri.AbsoluteUri.Length > range)
                            {
                                strData.Append(" xmlns:" + se.NamespacePrefix + "\t: " + XMLEncoding(se.NamespaceUri.AbsoluteUri.Substring(0, range) + "..."));
                            }
                            else if(se.NamespaceUri.AbsoluteUri.Length !=0)
                            {
                                strData.Append(" xmlns:" + se.NamespacePrefix + "\t: " + XMLEncoding(se.NamespaceUri.AbsoluteUri));                            
                            }
                            strData.Append(Environment.NewLine);
                            break;
                        }
                    }
                }

                if (feed03.XmlLang != DefaultValues.Language)
                {
                    strData.Append(" Xml Language\t: " + Utility.ParseLanguage(feed03.XmlLang) + Environment.NewLine);
                }

                if (feed03.Title.Content.Length > range)
                {
                    strData.Append("   Title\t: " + XMLEncoding(feed03.Title.Content.Substring(0, 40)) + "..."+Environment.NewLine);

                }
                else if (feed03.Title.Content.Length != 0)
                {
                    strData.Append("   Title\t: " + XMLEncoding(feed03.Title.Content) + Environment.NewLine);                                   
                }                 

                if (feed03.Title.Mode != DefaultValues.Mode)
                {
                    strData.Append("\tMode\t: " + feed03.Title.Mode + Environment.NewLine);                       
                }
                if (feed03.Title.Type != DefaultValues.MediaType)   
                {
                    strData.Append("\tType\t: " + Utility.ParseMediaType(feed03.Title.Type) + Environment.NewLine);                      
                }               
                          
                foreach (AtomLink link in feed03.Links)
                {
                    strData.Append("   Link\t\t" + Environment.NewLine);
                    strData.Append("\tRel\t: " + Utility.ParseRelationship(link.Rel )+ Environment.NewLine);
                    strData.Append("\tType\t: " + Utility.ParseMediaType(link.Type) + Environment.NewLine);                       
                    if (link.HRef != DefaultValues.FeedUri)
                    {
                        if (link.HRef.AbsoluteUri.Length > 40)
                        {
                            strData.Append("\tHref\t: " + XMLEncoding(link.HRef.AbsoluteUri.Substring(0, 40)) + "...");
                        }
                        else
                        {
                            strData.Append("\tHref\t: " + XMLEncoding(link.HRef.AbsoluteUri));
                        
                        }
                        strData.Append(Environment.NewLine);
                    }
                  
                    if (link.Title.Length > range)
                    {
                        strData.Append("\tTitle\t: " + XMLEncoding(link.Title.Substring(0, range)) + "..." + Environment.NewLine);   
                    }
                    else if(link.Title.Length != 0)
                    {
                        strData.Append("\tTitle\t: " + XMLEncoding(link.Title) + Environment.NewLine);                           
                    } 
                 }              
             
                if (feed03.Author != null)
                {
                    strData.Append("   Author\t" + Environment.NewLine);
                 
                    if (feed03.Author.Name.Length > range)
                    {
                        strData.Append("\tName\t: " + XMLEncoding(feed03.Author.Name.Substring(0, range)) + "..." + Environment.NewLine);
                    }
                    else if (feed03.Author.Name.Length != 0)
                    {
                        strData.Append("\tName\t: " + XMLEncoding(feed03.Author.Name) + Environment.NewLine);
                                         
                    }
                    if (feed03.Author.Url != DefaultValues.FeedUri)
                    {
                        if (feed03.Author.Url.AbsoluteUri.Length > range)
                        {
                            strData.Append("\tUrl\t: " + XMLEncoding(feed03.Author.Url.AbsoluteUri.Substring(0, range)) + "..." + Environment.NewLine);
                        }
                        else
                        {
                            strData.Append("\tUrl\t: " + XMLEncoding((feed03.Author.Url.AbsoluteUri)) + Environment.NewLine);
                        }
                    }
                    if (feed03.Author.Email.Length > 40)
                    {
                        strData.Append("\tEmail\t: " + XMLEncoding(feed03.Author.Email).Substring(0, 40) + "..." + Environment.NewLine);
                     }
                    else if (feed03.Author.Email.Length != 0)
                    {
                        strData.Append("\tEmail\t: " + XMLEncoding(feed03.Author.Email) + Environment.NewLine);                                    
                    }                                 
                 }          

                if (feed03.Contributors != null)
                {
                    foreach (AtomPersonConstruct contribute in feed03.Contributors)
                    {
                        strData.Append("   Contributor");
                        strData.Append(Environment.NewLine);
                        if (contribute.Name.Length > range )
                        {
                            strData.Append("\tName\t: " + XMLEncoding(contribute.Name.Substring(0, range) + "...") + Environment.NewLine);
                        }
                        else if (contribute.Name.Length != 0)
                        {
                            strData.Append("\tName\t: " + XMLEncoding(contribute.Name) + Environment.NewLine);                            
                        }
                        if (contribute.Url != DefaultValues.FeedUri)
                        {
                            if (contribute.Url.AbsoluteUri.Length > range)
                            {
                                strData.Append("\tUrl\t: " + XMLEncoding(contribute.Url.AbsoluteUri.Substring(0, range)) + "..." + Environment.NewLine);                               
                            }
                            else
                            {
                                strData.Append("\tUrl\t: " + XMLEncoding(contribute.Url.AbsoluteUri) + Environment.NewLine);                            
                            }
                        }
                        if(contribute.Email.Length >range)
                        {
                            strData.Append("\tEmail\t: " + XMLEncoding(contribute.Email.Substring(0, range)) + "..." + Environment.NewLine);
                        }
                        else if (contribute.Email.Length != 0)      
                        {
                            strData.Append("\tEmail\t: " + XMLEncoding(contribute.Email) + Environment.NewLine);                                                
                        }
                    }
                }
                if (feed03.Id != DefaultValues.FeedUri)
                {
                    if (feed03.Id.AbsoluteUri.Length > range)
                    {
                        strData.Append("   Id\t\t: " + XMLEncoding(feed03.Id.AbsoluteUri.Substring(0, range)) + "...");
                    }
                    else
                    {
                        strData.Append("   Id\t\t: " + XMLEncoding(feed03.Id.AbsoluteUri));                    
                    }
                    strData.Append(Environment.NewLine);
                }

                if (feed03.Copyright != null)
                {
                    if (feed03.Copyright.Content.Length > range)
                    {
                        strData.Append("   Copyright\t: " + XMLEncoding(feed03.Copyright.Content.Substring(0,range)) + "...");
                        strData.Append(Environment.NewLine);
                    
                    }
                    else if (feed03.Copyright.Content.Length  != 0)
                    {
                        strData.Append("   Copyright\t: " + XMLEncoding(feed03.Copyright.Content)+ Environment.NewLine);                  
                    }
                }

                if (feed03.Info != null)
                {                   
                    if (feed03.Info.Content.Length > range)
                    {
                       strData.Append("   Info\t\t: " + XMLEncoding(feed03.Info.Content.Substring(0,range)) + "...");
                    }
                    else
                    {
                        strData.Append("   Info\t\t: " + XMLEncoding(feed03.Info.Content));
                    
                    }
                    strData.Append(Environment.NewLine);
                    if(feed03.Info.Mode != DefaultValues.Mode)
                    {
                        strData.Append("\tMode\t: " + feed03.Info.Mode + Environment.NewLine);
                    }
                    if(feed03.Info.Type != DefaultValues.MediaType)  
                    {
                        strData.Append("\tType\t: " + Utility.ParseMediaType(feed03.Info.Type) + Environment.NewLine);
                    }             
                }

                if (feed03.Modified != null) 
                {
                    strData.Append("   Modified\t: " + ParseDate(feed03.Modified) + Environment.NewLine);                   
                }

                if (feed03.Tagline != null)
                {
                    if (feed03.Tagline.Content.Length > range)
                    {
                        strData.Append("   TagLine\t: " + XMLEncoding(feed03.Tagline.Content.Substring(0,range)) + "...");
                    }
                    else if (feed03.Tagline.Content.Length != 0)
                    {
                        strData.Append("   TagLine\t: " + XMLEncoding(feed03.Tagline.Content));
                    }
                    strData.Append(Environment.NewLine);

                    if (feed03.Tagline.Mode != DefaultValues.Mode)
                    {
                        strData.Append("\tMode\t: " + feed03.Tagline.Mode);
                        strData.Append(Environment.NewLine);
                    }
                    if (feed03.Tagline.Type != DefaultValues.MediaType) 
                    {
                        strData.Append("\tType\t: " + Utility.ParseMediaType(feed03.Tagline.Type) + Environment.NewLine);
                    }                  
                }                
                DisplayEntry03(feed03);
                return strData.ToString();
            }
        #endregion
      
        #region Entry

        private void DisplayEntry03(AtomFeed03 feed03)
        {
            strData.Append(Environment.NewLine);
            foreach (AtomEntry03 entry in feed03.Entries)
            {
                strData.Append("Entry\t" + Environment.NewLine);
                          
                if (entry.Title.Content.Length >range)
                {
                    strData.Append("   Title\t: " + XMLEncoding(entry.Title.Content.Substring(0, range)) + "...");
                }
                else if (entry.Title.Content.Length != 0)
                {
                    strData.Append("   Title\t: " + XMLEncoding(entry.Title.Content));
                }
                strData.Append(Environment.NewLine);
               
                if(entry.Title.Mode != DefaultValues.Mode)
                {
                    strData.Append("\tMode\t: " + entry.Title.Mode + Environment.NewLine);                   
                }
                if (entry.Title.Type != DefaultValues.MediaType)  
                {
                    strData.Append("\tType\t: " + Utility.ParseMediaType(entry.Title.Type) + Environment.NewLine);             
                }

                if (entry.Links != null)
                {
                    foreach (AtomLink link in entry.Links)
                    {
                        strData.Append("   Link\t " + Environment.NewLine);
                        strData.Append("\tRel\t: " + Utility.ParseRelationship(link.Rel) + Environment.NewLine);
                        strData.Append("\tType\t: " + Utility.ParseMediaType(link.Type) + Environment.NewLine);
                   
                        if (link.HRef != DefaultValues.FeedUri)
                        {
                            if (link.HRef.AbsoluteUri.Length > range)
                            {
                                strData.Append("\tHref\t: " + XMLEncoding(link.HRef.AbsoluteUri.Substring(0, range)) + "...");
                            }
                            else
                            {
                                strData.Append("\tHref\t: " + XMLEncoding(link.HRef.AbsoluteUri));
                            
                            }
                            strData.Append(Environment.NewLine);
                        }                      
                      
                        if (link.Title.Length > range)
                        {
                            strData.Append("\tTitle\t: " + XMLEncoding(link.Title.Substring(0, range)) + "..." + Environment.NewLine);
                        }
                        else if (link.Title.Length  != 0)
                        {
                            strData.Append("\tTitle\t: " + XMLEncoding(link.Title) + Environment.NewLine);                          
                        }                         
                    }                    
                }

                if (entry.Author != null)
                {
                    strData.Append("   Author\t" + Environment.NewLine);
                    if (entry.Author.Name.Length >range)
                    {
                        strData.Append("\tName\t: " + XMLEncoding(entry.Author.Name.Substring(0, range)) + "...");
                        strData.Append(Environment.NewLine);
                    }
                    else if(entry.Author.Name.Length != 0)
                    {
                        strData.Append("\tName\t: " + XMLEncoding(entry.Author.Name)+ Environment.NewLine);     
                    }
                    if (entry.Author.Uri != DefaultValues.FeedUri)
                    {
                        if (entry.Author.Url.AbsoluteUri.Length > range)
                        {
                            strData.Append("\tUrl\t: " + XMLEncoding(entry.Author.Url.AbsoluteUri.Substring(0, range)) + "...");
                            strData.Append(Environment.NewLine);
                        }
                        else
                        {
                            strData.Append("\tUrl\t: " + XMLEncoding(entry.Author.Url.AbsoluteUri)+Environment.NewLine);
                        }
                    }
                    if (entry.Author.Email.Length > range)
                    {
                        strData.Append("\tEmail\t: " + XMLEncoding(entry.Author.Email.Substring(0, range)) + "...");
                        strData.Append(Environment.NewLine);
                    }
                    else if (entry.Author.Email.Length != 0)
                    {
                        strData.Append("\tEmail\t: " + XMLEncoding(entry.Author.Email) + Environment.NewLine);                                
                    }
                }                
                if (entry.Contributors != null )
                {                    
                    foreach (AtomPersonConstruct contribute in entry.Contributors)
                    {
                        strData.Append(Environment.NewLine + "   Contribute\t" + Environment.NewLine);
                     
                        if (contribute.Name.Length != 0)
                        {
                            strData.Append("\tName\t: " + XMLEncoding(contribute.Name) + Environment.NewLine);
                        }
                        if (contribute.Url != DefaultValues.FeedUri)
                        {
                            if (contribute.Url.AbsoluteUri.Length > range)
                            {
                                strData.Append("\tUrl\t: " + XMLEncoding(contribute.Url.AbsoluteUri.Substring(0, range)) + "...");
                                strData.Append(Environment.NewLine);
                            }
                            else
                            {
                                strData.Append("\tUrl\t: " + XMLEncoding(contribute.Url.AbsoluteUri) + Environment.NewLine);
                            }
                        }
                        if(contribute.Email.Length > range)
                        {
                            strData.Append("\tEmail\t: " + XMLEncoding(contribute.Email.Substring(0, range)) + "...");
                            strData.Append(Environment.NewLine);
                        }
                        else if (contribute.Email.Length != 0)
                        {
                            strData.Append("\tEmail\t: " + XMLEncoding(contribute.Email)+ Environment.NewLine);                                
                        }
                    }
                }
                if (entry.Id != DefaultValues.FeedUri)
                {
                    if (entry.Id.AbsoluteUri.Length > range)
                    {
                       strData.Append("   Id\t\t: " + XMLEncoding(entry.Id.AbsoluteUri.Substring(0, range)) + "...");
                       strData.Append(Environment.NewLine);
                    }
                    else if (entry.Id.AbsoluteUri.Length != 0)
                    {
                       strData.Append("   Id\t\t: " + XMLEncoding(entry.Id.AbsoluteUri) + Environment.NewLine);                               
                    }
                }

                if(entry.Modified != null)   
                {
                    strData.Append("   Modified\t: " + ParseDate(entry.Modified) + Environment.NewLine);
                }
                if(entry.Issued != null)  
                {
                    strData.Append("   Issued\t: " + ParseDate(entry.Issued) + Environment.NewLine);                   
                }

                if (entry.Created != null)  
                {
                    strData.Append("   Created\t: " + ParseDate(entry.Created) + Environment.NewLine);
                }

                if (entry.Summary != null)
                { 
                    if (entry.Summary.Content.Length >range)
                    {
                        strData.Append("   Summary\t: " + XMLEncoding(entry.Summary.Content.Substring(0, range)) + "...");
                    }
                    else if(entry.Summary.Content.Length  != 0)
                    {
                        strData.Append("   Summary\t: " + XMLEncoding(entry.Summary.Content));                
                    }
                    strData.Append(Environment.NewLine);
                    if (entry.Summary.Type != DefaultValues.MediaType)  
                    {
                        strData.Append("\tType\t: " + Utility.ParseMediaType(entry.Summary.Type) + Environment.NewLine);
                    }
                    if (entry.Summary.Mode != DefaultValues.Mode)
                    {
                        strData.Append("\tMode\t: " + entry.Summary.Mode + Environment.NewLine);                  
                    }
                }     
           
                if (entry.Contents != null)
                {                    
                    foreach (AtomContent content in entry.Contents)
                    {                 
                        if (content.Content.Length > 40)
                        {
                            strData.Append("   Content\t: " + XMLEncoding(content.Content.Substring(0, 40)));
                        }
                        else
                        {
                            strData.Append("   Content\t: " + XMLEncoding(content.Content));                        
                        }
                        strData.Append(Environment.NewLine);
                        if (content.Type != DefaultValues.MediaType)  
                        {
                            strData.Append("\tType\t: " + Utility.ParseMediaType(content.Type) + Environment.NewLine);
                         
                        }
                        if (content.Mode != DefaultValues.Mode)
                        {
                            strData.Append("\tMode\t: " + content.Mode + Environment.NewLine);                           
                        }
                    }
                }

                if(entry.AdditionalElements != null)   
                {
                    foreach (ScopedElement scoped in entry.AdditionalElements)
                    {
                        if (scoped.NamespacePrefix.Length != 0)
                        {
                            if (scoped.Content.Length > range)
                            {
                                strData.Append("   " + XMLEncoding(scoped.NamespacePrefix) + ":" + scoped.LocalName + "\t: ");
                                strData.Append(XMLEncoding(scoped.Content.Substring(0, range)) + "..." + Environment.NewLine);
                               
                            }
                            else if (scoped.Content.Length != 0)
                            {
                                strData.Append("   " + XMLEncoding(scoped.NamespacePrefix) + ":" + scoped.LocalName + "\t: ");
                                strData.Append(XMLEncoding(scoped.Content) + Environment.NewLine);                                
                            }

                        }             
                    }
                }
                strData.Append(Environment.NewLine); 
            }
        }
     #endregion

        #region ParseDate
         private string ParseDate(AtomDateConstruct dtDate)
         {
            System.IFormatProvider providerCulture = System.Globalization.CultureInfo.CurrentCulture;
            
            string utcOffset = "";
            string sign = "";
            if(dtDate.UtcOffset == DefaultValues.UtcOffset)
			    utcOffset = "Z";
		    else
		    {
			    utcOffset = dtDate.UtcOffset.ToString().Substring(0,
				    dtDate.UtcOffset.ToString().Length - 3);
			    sign = "+";

			    // check if time zone is before GMT
			    if(utcOffset[0].Equals('-'))
				    sign = String.Empty;
		    }

		    string dateTime = dtDate.DateTime.ToString("s",providerCulture);

		    string tempStr = String.Format(providerCulture,"{0}{1}{2}",
			    dateTime,
			    sign,
			    utcOffset);
            return tempStr;

          }
      #endregion

        #region Encoding

        private string XMLEncoding(string stitle)
        {
            StringBuilder strBuild = new StringBuilder(stitle);

            strBuild.Replace("&amp;", "")
               .Replace("&apos;", "'")
               .Replace("&quot;", "\"")
               .Replace("&lt;", "<")
               .Replace("&gt;", ">")
               .Replace("\n", "")
               .Replace("\r", "");

            return strBuild.ToString().Trim();

        }
        #endregion

     }
   }
