/*
	* Atom10.cs
	* Copyright  2002 - 2008 ToolButton Inc. All Rights Reserved. 
*/

using System;
using System.Text;
using Web20Tools.Feed.Atom;

namespace AtomConvert
{
    public class Atom10
    {
        private StringBuilder strData;
        private const int range = 45;

        #region Feed
        public string DisplayFeed10(AtomFeed10 feed10)
        {
            strData = new StringBuilder();
            strData.Append("Feed    " + Environment.NewLine);
            strData.Append(" Version\t: Atom 1.0" + Environment.NewLine);    
            strData.Append(" xmlns\t\t: http://www.w3.org/2005/Atom" + Environment.NewLine);  
           
            if (feed10.XmlLang != DefaultValues.Language)
            {
                strData.Append(" Xml Language\t: " + Utility.ParseLanguage(feed10.XmlLang) + Environment.NewLine);
            }

            if (feed10.AdditionalElements.Count > 0)
            {
                ScopedElement se = feed10.AdditionalElements[0];
                strData.Append(" xmlns:" + se.NamespacePrefix + "\t\t: " + XMLEncoding(se.NamespaceUri.AbsoluteUri.Substring(0, range) + "..."));
                strData.Append(Environment.NewLine);
            }
            else
            {
                foreach (AtomEntry10 entry in feed10.Entries)
                {
                    if (entry.AdditionalElements.Count > 0)
                    {
                        ScopedElement se = entry.AdditionalElements[0];
                        if (se.NamespaceUri.AbsoluteUri.Length > range)
                        {
                            strData.Append(" xmlns:" + se.NamespacePrefix + "\t: " + XMLEncoding(se.NamespaceUri.AbsoluteUri.Substring(0, range) + "..."));

                        }
                        else if (se.NamespaceUri.AbsoluteUri.Length != 0)
                        {
                            strData.Append(" xmlns:"+ se.NamespacePrefix  +"\t: " + XMLEncoding(se.NamespaceUri.AbsoluteUri));
                        }

                        strData.Append(Environment.NewLine);
                        break;
                    }
                }
            }

            if (feed10.Title.Content.Length > range)
            {
                strData.Append("   Title\t: " +  XMLEncoding(feed10.Title.Content.Substring(0, range)) + "..." + Environment.NewLine);
            }
            else if (feed10.Title.Content.Length != 0)
            {
                strData.Append("   Title\t: " +  XMLEncoding(feed10.Title.Content) + Environment.NewLine);
            }

            if (feed10.Title.Type  != DefaultValues.MediaType)
            {
                strData.Append("\tType\t: " + Utility.ParseMediaType(feed10.Title.Type) + Environment.NewLine);
            }

            if (feed10.Title.Mode != DefaultValues.Mode)
            {
                strData.Append("\tMode\t: " + feed10.Title.Mode + Environment.NewLine);
            }
           
            if (feed10.Categories != null)   
            {
                foreach (AtomCategoryConstruct category in feed10.Categories)
                {
                    strData.Append("   Category     " + Environment.NewLine);
                    if (category.Term.Length > range)
                    {
                        strData.Append("\tTerm\t: " + XMLEncoding(category.Term.Substring(0, range)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("\tTerm\t: " + XMLEncoding(category.Term) + Environment.NewLine);                    
                    }

                    if (category.Label.Length > range)
                    {
                        strData.Append("\tLabel\t: "  + XMLEncoding(category.Label.Substring(0, range)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("\tLabel\t: "  + XMLEncoding(category.Label) + Environment.NewLine);                    
                    }   
              
                    if (category.Label.Length > range)
                    {
                        strData.Append("\tScheme\t: " + XMLEncoding(category.Scheme.AbsoluteUri.Substring(0, range)) + "..." + Environment.NewLine);
                    }
                    else
                    {
                        strData.Append("\tScheme\t: "  + XMLEncoding(category.Scheme.AbsoluteUri) + Environment.NewLine);
                    }       
                }
            }

            if (feed10.Links != null) 
            {
                foreach (AtomLink link in feed10.Links)
                {
                    strData.Append("   Link  ");
                    strData.Append(Environment.NewLine + "\tRel\t: " +  Utility.ParseRelationship(link.Rel));
                    strData.Append(Environment.NewLine + "\tType\t: " + Utility.ParseMediaType(link.Type));
                
                    if (link.HRef != DefaultValues.FeedUri)
                    {
                        if (link.HRef.AbsoluteUri.Length > range)
                        {
                            strData.Append(Environment.NewLine + "\tHref\t: " + XMLEncoding(link.HRef.AbsoluteUri.Substring(0, range)) + "...");
                        }
                        else
                        {
                            strData.Append(Environment.NewLine + "\tHref\t: " + XMLEncoding(link.HRef.AbsoluteUri));
                        }                        
                    }

                    if (link.HrefLang != DefaultValues.Language)
                    {                       
                        strData.Append(Environment.NewLine + "\tHrefLang: " + Utility.ParseLanguage(link.HrefLang));
                    }
                    if (link.Length != -1)
                    {                       
                        strData.Append(Environment.NewLine + "\tLength\t: " + link.Length);
                    }
                    if (link.Title.Length >range)
                    {
                        strData.Append(Environment.NewLine + "\tTitle\t: " + XMLEncoding(link.Title.Substring(0, range)) + "...");
                    }
                    else if (link.Title.Length != 0)
                    {
                        strData.Append(Environment.NewLine + "\tTitle\t: " + XMLEncoding(link.Title));
                    }
                    strData.Append(Environment.NewLine);
                }
            }
                        
            if (feed10.Authors != null)
            {
                foreach (AtomPersonConstruct author in feed10.Authors)
                {
                    strData.Append("   Author      " + Environment.NewLine);
                    if (author.Name.Length > range)
                    {
                        strData.Append("\tName\t: " +  XMLEncoding(author.Name.Substring(0,range)) +"..." + Environment.NewLine);
                    }
                    else if (author.Name.Length != 0)
                    {
                        strData.Append("\tName\t: " +  XMLEncoding(author.Name) + Environment.NewLine);
                    }
                    if (author.Uri != DefaultValues.FeedUri) 
                    {
                        if (author.Uri.AbsoluteUri.Length > range)
                        {
                            strData.Append("\tUri\t: " +  XMLEncoding(author.Uri.AbsoluteUri.Substring(0, range)) + "..." + Environment.NewLine);
                        }
                        else
                        {
                            strData.Append("\tUri\t: " +  XMLEncoding(author.Uri.AbsoluteUri) + Environment.NewLine);
                        }                     
                    }
                    if (author.Email.Length >= range)
                    {                        
                        strData.Append("\tEmail\t: " +  XMLEncoding(author.Email.Substring(0,range)) +"..." + Environment.NewLine);                      
                    }
                    else if (author.Email.Length != 0)
                    {
                        strData.Append("\tEmail\t: " + XMLEncoding(author.Email) + Environment.NewLine);    
                    }
                }
            }
            if (feed10.Contributors != null)
            {   
                foreach (AtomPersonConstruct contribute in feed10.Contributors)
                {                  
                    strData.Append("   Contributor   ");
                    strData.Append(Environment.NewLine);
                    if (contribute.Name.Length > range)
                    {
                        strData.Append("\tName\t: " + XMLEncoding(contribute.Name.Substring(0, range)) + "..." + Environment.NewLine);
                    }
                    else if (contribute.Name.Length != 0)
                    {
                        strData.Append("\tName\t: " + XMLEncoding(contribute.Name) + Environment.NewLine);                                 
                    }
                    if (contribute.Uri  != DefaultValues.FeedUri)  
                    {
                        if (contribute.Uri.AbsoluteUri.Length > range)
                        {
                            strData.Append("\tUri\t: " + XMLEncoding(contribute.Uri.AbsoluteUri.Substring(0, range)) + "...");
                            strData.Append(Environment.NewLine);
                        }
                        else
                        {
                            strData.Append("\tUri\t: " + XMLEncoding(contribute.Uri.AbsoluteUri));
                            strData.Append(Environment.NewLine);
                        }                      
                    }
                    if (contribute.Email.Length > range)
                    {
                        strData.Append("\tEmail\t: " + XMLEncoding(contribute.Email.Substring(0, range)) + "..." + Environment.NewLine);                        
                    }
                    else if(contribute.Email.Length  != 0)
                    {
                        strData.Append("\tEmail\t: " + XMLEncoding(contribute.Email) + Environment.NewLine);                      
                    }
                }
            }

            if (feed10.Id != DefaultValues.FeedUri)
            {               
                if (feed10.Id.AbsoluteUri.Length > range)
                {
                    strData.Append("   Id\t\t: " + XMLEncoding(feed10.Id.AbsoluteUri.Substring(0, range)) + "...");
                }
                else
                {
                    strData.Append("   Id\t\t: " + XMLEncoding(feed10.Id.AbsoluteUri));
                }
                strData.Append(Environment.NewLine);          
            }
          
            if (feed10.Icon != null)
            {
                if (feed10.Icon.Content.Length >range)
                {
                    strData.Append("   Icon\t\t: " + XMLEncoding(feed10.Icon.Content.Substring(0,range)) + "...");
                    strData.Append(Environment.NewLine);
                }
                else if (feed10.Icon.Content.Length != 0)
                {
                    strData.Append("   Icon\t\t: " + XMLEncoding(feed10.Icon.Content) + Environment.NewLine);                              
                }
            }
         
            if (feed10.Logo != null)
            {
                if (feed10.Logo.Content.Length > range)
                {
                    strData.Append("   Logo\t\t: " + XMLEncoding(feed10.Logo.Content.Substring(0,range))+"...");
                  
                }
                else if (feed10.Logo.Content.Length != 0)
                { 
                    strData.Append("   Logo\t\t: " + XMLEncoding(feed10.Logo.Content));                         
                }
                strData.Append(Environment.NewLine);     
            }

            if (feed10.Rights != null)
            {
                if (feed10.Rights.Content.Length > range)
                {
                    strData.Append("   Rights\t: " + XMLEncoding(feed10.Rights.Content.Substring(0, range)) + "...");
                }
                else if (feed10.Rights.Content.Length != 0)
                {
                    strData.Append("   Rights\t: " + XMLEncoding(feed10.Rights.Content));
                }
                strData.Append(Environment.NewLine);
                if (feed10.Rights.Mode != DefaultValues.Mode)
                {
                    strData.Append("\tMode\t: " + feed10.Rights.Mode);
                    strData.Append(Environment.NewLine);
                }
                if (feed10.Rights.Type != DefaultValues.MediaType)
                {
                    strData.Append("\tType\t: " + Utility.ParseMediaType(feed10.Rights.Type));
                    strData.Append(Environment.NewLine);
                }       
            }

            if (feed10.Updated != null)  
            {
                strData.Append("   Updated\t: " + ParseDate(feed10.Updated));
                strData.Append(Environment.NewLine);
            }

            if(feed10.Subtitle != null) 
            {    
                if(feed10.Subtitle.Content.Length > range)
                {
                    strData.Append("   SubTitle\t: " + XMLEncoding(feed10.Subtitle.Content.Substring(0,range)) + "...");
                }
                else if (feed10.Subtitle.Content.Length != 0)
                {
                    strData.Append("   SubTitle\t: " + XMLEncoding(feed10.Subtitle.Content));
                
                }
                strData.Append(Environment.NewLine);
                if (feed10.Subtitle.Mode != DefaultValues.Mode)
                {
                    strData.Append("\tMode\t: " + feed10.Subtitle.Mode + Environment.NewLine);                 
                }
                if (feed10.Subtitle.Type != DefaultValues.MediaType)
                {
                     strData.Append("\tType\t: " + Utility.ParseMediaType(feed10.Subtitle.Type) + Environment.NewLine);    
                }
             }

             DisplayEntry10(feed10);
             return strData.ToString();

         }
         #endregion

         #region Entry  

         private void DisplayEntry10(AtomFeed10 feed10)
         {
            strData.Append(Environment.NewLine); 
            foreach (AtomEntry10 entry in feed10.Entries)
            {              
                strData.Append("Entry  ");
                strData.Append(Environment.NewLine);
             
                if (entry.Title.Content.Length > 50)
                {
                    strData.Append("   Title\t: " + XMLEncoding(entry.Title.Content.Substring(0, 50)) + "...");
                }
                else if (entry.Title.Content.Length != 0)
                {
                    strData.Append("   Title\t: " + XMLEncoding(entry.Title.Content));
                }
                strData.Append(Environment.NewLine);

                if (entry.Title.Mode != DefaultValues.Mode)
                {
                    strData.Append("\tMode\t: " + entry.Title.Mode);
                    strData.Append(Environment.NewLine);
                }

                if (entry.Title.Type != DefaultValues.MediaType)
                {
                    strData.Append("\tType\t: " + Utility.ParseMediaType(entry.Title.Type));
                    strData.Append(Environment.NewLine);
                }

                foreach (AtomLink link in entry.Links)
                {                   
                    strData.Append("   Link     ");
                    strData.Append(Environment.NewLine);
                    strData.Append("\tRel\t: " + Utility.ParseRelationship(link.Rel) + Environment.NewLine);
                    strData.Append("\tType\t: " + Utility.ParseMediaType(link.Type) + Environment.NewLine);
                    if (link.HRef != DefaultValues.FeedUri)
                    {
                        if (link.HRef.AbsoluteUri.Length > 50)
                        {
                            strData.Append("\tHref\t: " + XMLEncoding(link.HRef.AbsoluteUri.Substring(0, 50)) + "..." + Environment.NewLine);
                        }
                        else
                        {
                            strData.Append("\tHref\t: " + XMLEncoding(link.HRef.AbsoluteUri) + Environment.NewLine);
                        }                      
                    }   

                    if (link.Title.Length > range)
                    {
                        strData.Append("\tTitle\t: " + XMLEncoding(link.Title.Substring(0, range)) + "..." + Environment.NewLine);
                    }
                    else if (link.Title.Length != 0)
                    {
                        strData.Append("\tTitle\t: " + XMLEncoding(link.Title) + Environment.NewLine);
                    }
                   
                    if (link.Length != -1)
                    {
                        strData.Append("\tLength\t: " + link.Length + Environment.NewLine);                    
                    }
                    if (link.HrefLang != DefaultValues.Language)
                    {
                        strData.Append("\tLaunguage : " + Utility.ParseLanguage(link.HrefLang) + Environment.NewLine);                        
                    }                   
                }

                if (entry.Categories != null)
                {                   
                    foreach (AtomCategoryConstruct category in entry.Categories)
                    {
                        strData.Append("   Category       " + Environment.NewLine);
                        if(category.Term.Length != 0)
                        {
                            strData.Append("\tTerm\t: " + category.Term+Environment.NewLine);                      
                        }
                        if (category.Scheme != DefaultValues.FeedUri)  
                        {
                            if (category.Scheme.AbsoluteUri.Length > range)
                            {
                                strData.Append("\tScheme\t: " + XMLEncoding(category.Scheme.AbsoluteUri.Substring(0, range)) + "..." + Environment.NewLine);
                            }
                            else
                            {
                                strData.Append("\tScheme\t: " + XMLEncoding(category.Scheme.AbsoluteUri) + Environment.NewLine);
                            }
                        }
                        if (category.Label.Length != 0)
                        {
                            strData.Append("\tLabel\t: " + category.Label + Environment.NewLine);                           
                        }
                    }
                }
              
                if(entry.Authors != null)
                {
                    foreach (AtomPersonConstruct author in entry.Authors)
                    {
                        strData.Append("   Author  " + Environment.NewLine);
                      
                        if (author.Name.Length > 50)
                        {
                            strData.Append("\tName\t: " + XMLEncoding(author.Name.Substring(0, 50)) + "..." + Environment.NewLine);
                          
                        }
                        else if (author.Name.Length != 0)
                        {
                            strData.Append("\tName\t: " + XMLEncoding(author.Name) + Environment.NewLine);                           
                        }

                        if (author.Uri != DefaultValues.FeedUri)
                        {
                            if (author.Uri.AbsoluteUri.Length > range)
                            {
                                strData.Append("\tUri\t: " + XMLEncoding(author.Uri.AbsoluteUri.Substring(0, range)) + "..." + Environment.NewLine);
                             }
                            else
                            {
                                strData.Append("\tUri\t: " + XMLEncoding(author.Uri.AbsoluteUri)+ Environment.NewLine);
                            }
                        }

                        if (author.Email.Length > range)
                        {
                            strData.Append("\tEmail\t: " + XMLEncoding(author.Email.Substring(0, range)) + "..." + Environment.NewLine);
                            
                        }
                        else if (author.Email.Length != 0)
                        {
                            strData.Append("\tEmail\t: " + XMLEncoding(author.Email) + Environment.NewLine);                        
                        }
                   }
                }         
             
                if (entry.Contributors != null)
                {  
                    foreach (AtomPersonConstruct contribute in entry.Contributors)
                    {
                        strData.Append("   Contribute   " + Environment.NewLine);
                
                        if (contribute.Name.Length != 0)
                        {
                            strData.Append("\tName\t: " + contribute.Name + Environment.NewLine);                           
                        }

                        if (contribute.Uri != DefaultValues.FeedUri)
                        {
                            if (contribute.Uri.AbsoluteUri.Length > range)
                            {
                                strData.Append("\tUrl\t: " + contribute.Uri.AbsoluteUri.Substring(0, range) + "..." + Environment.NewLine);
                             
                            }
                            else
                            {
                                strData.Append("\tUrl\t: " + XMLEncoding(contribute.Uri.AbsoluteUri) + Environment.NewLine);
                           
                            }
                        }

                        if (contribute.Email.Length > range)
                        {
                            strData.Append("\tEmail\t: " + contribute.Email.Substring(0,range)+"...");
                            strData.Append(Environment.NewLine);
                        }
                        else if(contribute.Email.Length  != 0)
                        {
                            strData.Append("\tEmail\t: " + XMLEncoding(contribute.Email) + Environment.NewLine);                                       
                        }
                }

                if (entry.Updated != null)
                {
                    strData.Append("   Updated\t: " + ParseDate(entry.Updated));   
                    strData.Append(Environment.NewLine);
                }

                if (entry.Id != DefaultValues.FeedUri) 
                {                    
                   if (entry.Id.AbsoluteUri.Length > range)
                    {
                       strData.Append("   Id\t\t: " + XMLEncoding(entry.Id.AbsoluteUri.Substring(0,range)) + "...");
                       strData.Append(Environment.NewLine);
                    }
                    else if (entry.Id.AbsoluteUri.Length != 0)
                    { 
                       strData.Append("   Id\t\t: " + XMLEncoding(entry.Id.AbsoluteUri));
                       strData.Append(Environment.NewLine);                    
                    }
                }
                if (entry.Published != null )  
                {
                    strData.Append("   Published\t: " + ParseDate(entry.Published));
                    strData.Append(Environment.NewLine);
                }

                if (entry.Summary!= null)
                {
                    if (entry.Summary.Content.Length > range)
                    {
                        strData.Append("   Summary\t: " + XMLEncoding(entry.Summary.Content.Substring(0,range)) + "...");
                    }
                    else
                    {
                        strData.Append("   Summary\t: " + XMLEncoding(entry.Summary.Content));                    
                    }
                    if(entry.Summary.Type != DefaultValues.MediaType)
                    {
                        strData.Append(Environment.NewLine + "\tType\t: " + Utility.ParseMediaType(entry.Summary.Type));                    
                    }
                    if (entry.Summary.Mode != DefaultValues.Mode)
                    {
                        strData.Append(Environment.NewLine + "\tMode\t: " + entry.Summary.Mode);
                    }                   
                    strData.Append(Environment.NewLine); 
                }

                if (entry.Content.Content.Length  != 0)
                {
                    if (entry.Content.Content.Length > range)
                    {
                        strData.Append("   Content\t: " + XMLEncoding(entry.Content.Content.Substring(0, range)) + "...");                       
                    }
                    else
                    {
                        strData.Append("   Content\t: " + XMLEncoding(entry.Content.Content));        
                    }
                    strData.Append(Environment.NewLine);
                    if (entry.Content.Type != DefaultValues.MediaType)   
                    {
                        strData.Append("\tType\t: " + Utility.ParseMediaType(entry.Content.Type));             
                        strData.Append(Environment.NewLine);
                    }
                    if (entry.Content.Mode != DefaultValues.Mode)
                    {
                        strData.Append("\tMode\t: " + entry.Content.Mode);
                        strData.Append(Environment.NewLine);
                    }              
                }

                if (entry.Rights != null)
                {
                    if (entry.Rights.Content.Length > range)
                    {
                        strData.Append("   Rights\t: " + XMLEncoding(entry.Rights.Content.Substring(0,range)) + "...");                       
                    }
                    else if(entry.Rights.Content.Length != 0)
                    {
                        strData.Append("   Rights\t: " + XMLEncoding(entry.Rights.Content));                        
                    }
                    strData.Append(Environment.NewLine);
                }

                if (entry.Source != null)
                {
                    foreach(AtomSourceConstruct source in entry.Source)
                    {                      
                        strData.Append("   Source\t");
                        strData.Append(Environment.NewLine);
                        if (source.Id != DefaultValues.FeedUri)
                        {
                            if(source.Id.AbsoluteUri.Length > range)
                            {
                                strData.Append("\tId\t: " + XMLEncoding(source.Id.AbsoluteUri.Substring(0,range))+"...");
                                strData.Append(Environment.NewLine);
                            }
                            else if(source.Id.AbsoluteUri.Length !=0)
                            {
                                strData.Append("\tId\t: " + XMLEncoding(source.Id.AbsoluteUri));
                                strData.Append(Environment.NewLine);                            
                            }
                        }
                        if (source.Rights.Length != 0)
                        {
                            strData.Append("\tRights\t: " + source.Rights);
                            strData.Append(Environment.NewLine);
                        }
                        if (source.Title.Length > range)
                        {
                            strData.Append("\tTitle\t: " + XMLEncoding(source.Title.Substring(0,range))+"...");
                            strData.Append(Environment.NewLine);
                        }
                        else if(source.Title.Length != 0)
                        {
                            strData.Append("\tTitle\t: " + XMLEncoding(source.Title));
                            strData.Append(Environment.NewLine);                                               
                        }

                        if (source.Updated.DateTime != null)
                        {
                            strData.Append("\tUpdated\t: " + ParseDate(source.Updated));
                            strData.Append(Environment.NewLine);
                        }                      
                     }
                }             

                if (entry.AdditionalElements != null)   
                {
                    foreach (ScopedElement scoped in entry.AdditionalElements)
                    {
                        if(scoped.NamespacePrefix.Length != 0)
                        {
                            if (scoped.Content.Length > range)
                            {
                                strData.Append("   " + XMLEncoding(scoped.NamespacePrefix) + ":" + scoped.LocalName + "\t: ");
                                strData.Append(XMLEncoding(scoped.Content.Substring(0, range)) + "..." + Environment.NewLine);
                             }
                            else if (scoped.Content.Length != 0)
                            {
                                strData.Append("   " + XMLEncoding(scoped.NamespacePrefix) + ":" + scoped.LocalName + "\t: ");
                                strData.Append(XMLEncoding(scoped.Content) + Environment.NewLine);                           
                            }
                        }            
                 
                    }
                }
                strData.Append(Environment.NewLine);
            }
          }
         }
         #endregion

         #region ParseDate
         private string ParseDate(AtomDateConstruct dtDate)
        {
            System.IFormatProvider providerCulture = System.Globalization.CultureInfo.CurrentCulture;

            string utcOffset = "";
            string sign = "";
            if (dtDate.UtcOffset == DefaultValues.UtcOffset)
                utcOffset = "Z";
            else
            {
                utcOffset = dtDate.UtcOffset.ToString().Substring(0,
                    dtDate.UtcOffset.ToString().Length - 3);
                sign = "+";

                // check if time zone is before GMT
                if (utcOffset[0].Equals('-'))
                    sign = String.Empty;
            }

            string dateTime = dtDate.DateTime.ToString("s", providerCulture);

            string tempStr = String.Format(providerCulture, "{0}{1}{2}",
                dateTime,
                sign,
                utcOffset);
            return tempStr;

        }
        #endregion

        #region Encoding
        private string XMLEncoding(string stitle)
        {
            StringBuilder strBuild = new StringBuilder(stitle);

            strBuild.Replace("&amp;", "")
               .Replace("&apos;", "'")
               .Replace("&quot;", "\"")
               .Replace("&lt;", "<")
               .Replace("&gt;", ">")
               .Replace("\n", "")
               .Replace("\r", "");

            return strBuild.ToString().Trim();

        }
        #endregion
    }
}